
//NOTE: you must leave "precompiled headers" turned off
//  for this file, or include the following header file.
// If unsure how to do that, just left click on this file
//  in the list to the left, then "settings" and from the
//  C++ combo box, select "precompiled headers" and check
//  the radio button "not using precompiled headers"
//#include "stdafx.h"

//Last modified: 9-29-03

#include "USB_clss.h"
//#include <stdio.h>
// the following is just used for trouble-shooting
//  during application development.
//BOOLEAN fMsgBoxShownOnce = FALSE;


//#################################################################################\
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###    CONSTRUCTORS/DESTRUCTORS       CONSTRUCTORS/DESTRUCTORS   ################  
//##################################################################################
// ###    CONSTRUCTORS/DESTRUCTORS       CONSTRUCTORS/DESTRUCTORS   ################  
//##################################################################################
// ###    CONSTRUCTORS/DESTRUCTORS       CONSTRUCTORS/DESTRUCTORS   ################  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###    CONSTRUCTORS/DESTRUCTORS       CONSTRUCTORS/DESTRUCTORS   ################  
//##################################################################################
// ###    CONSTRUCTORS/DESTRUCTORS       CONSTRUCTORS/DESTRUCTORS   ################  
//##################################################################################
// ###    CONSTRUCTORS/DESTRUCTORS       CONSTRUCTORS/DESTRUCTORS   ################  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//#################################################################################/
//****************************************************************\
//================================================================*\
//==== BaseVarInit FUNCTION =======================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::BaseVarInit()
{
	hDLL = NULL;

	SP_DisableDialog			= NULL;
	SP_GetRegDevList			= NULL;
	SP_InitAllDevices			= NULL;

	SP_InitAllDevices_Thread	= NULL;
	SP_GetInitThreadStat		= NULL;
	SP_GetLastInitStat			= NULL;
	SP_GetLastInitDevAndRates	= NULL;

	SP_GetOneConversion			= NULL;
	SP_SendChan					= NULL;
	SP_SendDigOut				= NULL;
	DLL_StartScan				= NULL; 
	DLL_ReadScanData			= NULL; 
	DLL_ReadScanDataWithDigin	= NULL;
	SP_EndScan					= NULL; 
	SP_SendRate					= NULL;
	SP_SendDAC					= NULL;

	SP_SystemCalibration		= NULL;

	SP_GetDevStat				= NULL;
	SP_CheckPower				= NULL;

	SP_WriteWhileScanning		= NULL;

	uiLastAnyError				= ERR_NO_ERROR;

	memset(fInitFlags, 0, sizeof(fInitFlags));
	memset(usDevList_GLOBAL, 0, sizeof(usDevList_GLOBAL));
	memset(structDevices, 0, sizeof(structDevices));
	memset(fIsValidStructPntr, 0, sizeof(fIsValidStructPntr));

	GetOsVer_PRIVATE();

	return TRUE;
}





//****************************************************************\
//==== MyLL_USB(multiple device initialization, threaded) ========*\
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::Init(USHORT* usDevID, BYTE* bChan, DOUBLE* dblRate, BOOLEAN fThreaded)
{
	//7-12-010 BaseVarInit();
	BYTE bIndex;

	USHORT ausDevList_TEMP[32]; 
	DOUBLE adblRate_TEMP[32];
	BYTE abChan_TEMP[32]; 

	for(bIndex = 0; bIndex < 32; bIndex++) 
	{ 
		ausDevList_TEMP[bIndex] = usDevID[bIndex]; 
		adblRate_TEMP[bIndex] = dblRate[bIndex]; 
		abChan_TEMP[bIndex] = bChan[bIndex]; 
	}

	if(!Init_PRIVATE(ausDevList_TEMP, abChan_TEMP, adblRate_TEMP, fThreaded))
	{
		for(bIndex = 0; bIndex < 32; bIndex++) 
		{ 
			usDevID[bIndex] = 0; 
			dblRate[bIndex] = 0; 
			bChan[bIndex] = 0; 
		}
		uiLastAnyError = ERR_FAILED_INIT;
		return FALSE;
	}

	for(bIndex = 0; bIndex < 32; bIndex++)
	{ 
		usDevID[bIndex] = ausDevList_TEMP[bIndex]; 
		dblRate[bIndex] = adblRate_TEMP[bIndex]; 
		bChan[bIndex] = abChan_TEMP[bIndex]; 
	}
	uiLastAnyError = ERR_NO_ERROR;
	return TRUE;
}

//****************************************************************\
//==== MyLL_USB(multiple device initialization, non-threaded) ====*\
//================================================================*/
/*****************************************************************/
//BOOLEAN MyLL_USB::Init(USHORT* usDevID, BYTE* bChan, DOUBLE* dblRate, UINT uiOS_Code)
BOOLEAN MyLL_USB::Init(USHORT* usDevID, BYTE* bChan, DOUBLE* dblRate)
{
	//7-12-010 BaseVarInit();
	BYTE bIndex;

	USHORT ausDevList_TEMP[32]; 
	DOUBLE adblRate_TEMP[32];
	BYTE abChan_TEMP[32]; 

	for(bIndex = 0; bIndex < 32; bIndex++) 
	{ 
		ausDevList_TEMP[bIndex] = usDevID[bIndex]; 
		adblRate_TEMP[bIndex] = dblRate[bIndex]; 
		abChan_TEMP[bIndex] = bChan[bIndex]; 
	}

	if(!Init_PRIVATE(ausDevList_TEMP, abChan_TEMP, adblRate_TEMP))
	{
		for(bIndex = 0; bIndex < 32; bIndex++) 
		{ 
			usDevID[bIndex] = 0; 
			dblRate[bIndex] = 0; 
			bChan[bIndex] = 0; 
		}
		uiLastAnyError = ERR_FAILED_INIT;
		return FALSE;
	}

	for(bIndex = 0; bIndex < 32; bIndex++)
	{ 
		usDevID[bIndex] = ausDevList_TEMP[bIndex]; 
		dblRate[bIndex] = adblRate_TEMP[bIndex]; 
		bChan[bIndex] = abChan_TEMP[bIndex]; 
	}
	uiLastAnyError = ERR_NO_ERROR;
	return TRUE;
}

//****************************************************************\
//==== MyLL_USB() (single device initialization, non-threaded)====*\
//================================================================*/
/*****************************************************************/
//BOOLEAN MyLL_USB::Init(USHORT usDevID, BYTE bChan, DOUBLE* dblRate, UINT uiOS_Code)
BOOLEAN MyLL_USB::Init(USHORT usDevID, BYTE bChan, DOUBLE* dblRate)
{
	DOUBLE adblRate_TEMP = *dblRate;

	if(!Init_PRIVATE(usDevID, bChan, &adblRate_TEMP))
	{
		uiLastAnyError = ERR_FAILED_INIT;
		return FALSE;
	}

	*dblRate = adblRate_TEMP;
	uiLastAnyError = ERR_NO_ERROR;
	return TRUE;
}

//****************************************************************\
//==== MyLL_USB() ================================================*\
//================================================================*/
/*****************************************************************/
MyLL_USB::MyLL_USB()
{ BaseVarInit(); }


//****************************************************************\
//==== MyLL_USB() ================================================*\
//==== DESTRUCTOR FUNCTION ========================================*>
//================================================================*/
/*****************************************************************/
MyLL_USB::~MyLL_USB()
{
	BYTE bThisDevIndex;
	USHORT usCurDevID;
	BOOLEAN fDevFound = FALSE;
	for(bThisDevIndex = 0; bThisDevIndex < 32; bThisDevIndex++)
	{
		if((DEVICES*)structDevices[bThisDevIndex] != NULL)
		{
			if((structDevices[bThisDevIndex]->usDevID) != 0)
			{
				usCurDevID = structDevices[bThisDevIndex]->usDevID;
				if(GetCurDevInitStatus(usCurDevID))
				{
					BOOLEAN fOkayToStartScan;
					BOOLEAN fScanning;
					GetCurDevScanStatus(usCurDevID, &fOkayToStartScan, &fScanning);
					if(fScanning) 
					{
						EndScan(usCurDevID);
					}
				}
				if(usDevList_GLOBAL[bThisDevIndex] == usCurDevID) 
					usDevList_GLOBAL[bThisDevIndex] = 0;
				else
					for(BYTE bInnerIndex = 0; bInnerIndex < 32; bInnerIndex++)
					{
						if(usDevList_GLOBAL[bInnerIndex] == usCurDevID)
						{
							usDevList_GLOBAL[bThisDevIndex] = 0;
							break;
						}
					}
			}
			delete [] structDevices[bThisDevIndex];
		}
	}
}



//#################################################################################\
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###    ERROR AND LIST HANDLING       ERROR AND LIST HANDLING   ##################  
//##################################################################################
// ###    ERROR AND LIST HANDLING       ERROR AND LIST HANDLING   ##################  
//##################################################################################
// ###    ERROR AND LIST HANDLING       ERROR AND LIST HANDLING   ##################  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###    ERROR AND LIST HANDLING       ERROR AND LIST HANDLING   ##################  
//##################################################################################
// ###    ERROR AND LIST HANDLING       ERROR AND LIST HANDLING   ##################  
//##################################################################################
// ###    ERROR AND LIST HANDLING       ERROR AND LIST HANDLING   ##################  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###    ERROR AND LIST HANDLING       ERROR AND LIST HANDLING   ##################  
//##################################################################################
// ###    ERROR AND LIST HANDLING       ERROR AND LIST HANDLING   ##################  
//##################################################################################
// ###    ERROR AND LIST HANDLING       ERROR AND LIST HANDLING   ##################  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###    ERROR AND LIST HANDLING       ERROR AND LIST HANDLING   ##################  
//##################################################################################
// ###    ERROR AND LIST HANDLING       ERROR AND LIST HANDLING   ##################  
//##################################################################################
// ###    ERROR AND LIST HANDLING       ERROR AND LIST HANDLING   ##################  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###    ERROR AND LIST HANDLING       ERROR AND LIST HANDLING   ##################  
//##################################################################################
// ###    ERROR AND LIST HANDLING       ERROR AND LIST HANDLING   ##################  
//##################################################################################
// ###    ERROR AND LIST HANDLING       ERROR AND LIST HANDLING   ##################  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###    ERROR AND LIST HANDLING       ERROR AND LIST HANDLING   ##################  
//##################################################################################
// ###    ERROR AND LIST HANDLING       ERROR AND LIST HANDLING   ##################  
//##################################################################################
// ###    ERROR AND LIST HANDLING       ERROR AND LIST HANDLING   ##################  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//#################################################################################/
//****************************************************************\
//==== PRIVATE FUNCTION ==========================================*\
//==== GetZeroIndexDev_PRIVATE FUNCTION ===========================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetZeroIndexDev_PRIVATE(USHORT* _pusDevID)
{
	SHORT usDevID = 0;
	if(fIsValidStructPntr[0] != NULL)
	if(structDevices[0] != NULL)
	{
		if(structDevices[0]->usDevID == 0) 
		{ uiLastAnyError = ERR_DEV_NOT_FOUND; return FALSE;  }
	}
	usDevID = structDevices[0]->usDevID;

	*_pusDevID = usDevID;
	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== GetDefDev_SP FUNCTION ======================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetDefDev_SP(USHORT* pusDevID)
{
	return GetZeroIndexDev_PRIVATE(pusDevID);
}


//****************************************************************\
//================================================================*\
//==== GetCurDevInitStatus_SP FUNCTION ============================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetCurDevInitStatus_SP()
{
	USHORT usDevID = 0;
	if(!GetZeroIndexDev_PRIVATE(&usDevID))
	{ uiLastAnyError = ERR_DEV_NOT_FOUND; return FALSE;  }
	return GetCurDevInitStatus(usDevID);
}


//****************************************************************\
//==== PRIVATE FUNCTION ==========================================*\
//==== GetDevListIndex FUNCTION ===================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetDevListIndex(USHORT usDevID, BYTE* bIndex)
{
	BYTE bThisDevIndex;
	BOOLEAN fDevFound = FALSE;

	if(!usDevID) { uiLastAnyError = ERR_DEV_NOT_FOUND; return FALSE; }

	for(bThisDevIndex = 0; bThisDevIndex < 32; bThisDevIndex++)
	{
		if(fIsValidStructPntr[bThisDevIndex] != NULL)
		if(structDevices[bThisDevIndex] != NULL)
		{
			if(structDevices[bThisDevIndex]->usDevID == usDevID) { fDevFound = TRUE; break; }
		}
	}

	if(!fDevFound) { uiLastAnyError = ERR_DEV_NOT_FOUND; return FALSE; }

	*bIndex = bThisDevIndex;
	return TRUE;
}


//****************************************************************\
//================================================================*\
//==== GetLastAnyError FUNCTION ===================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetLastDevError(UINT usDevID, UINT* uiErrorCode)
{
	BYTE bIndexStructDevList;
	if(!GetDevListIndex(usDevID, &bIndexStructDevList))
	{
		uiLastAnyError = ERR_DEV_NOT_FOUND;
		*uiErrorCode = ERR_DEV_NOT_FOUND;
		return FALSE;
	}

	*uiErrorCode = structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev;
	return TRUE;
}


//****************************************************************\
//================================================================*\
//==== GetLastAnyError FUNCTION ===================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetLastAnyError(UINT* uiErrorCode)
{
	*uiErrorCode = uiLastAnyError;
	return TRUE;
}



//#################################################################################\
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###    INITIALIZATION      INITIALIZATION   INITIALIZATION   INITIALIZATION  ####  
//##################################################################################
// ###    INITIALIZATION      INITIALIZATION   INITIALIZATION   INITIALIZATION  ####  
//##################################################################################
// ###    INITIALIZATION      INITIALIZATION   INITIALIZATION   INITIALIZATION  ####  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###    INITIALIZATION      INITIALIZATION   INITIALIZATION   INITIALIZATION  ####  
//##################################################################################
// ###    INITIALIZATION      INITIALIZATION   INITIALIZATION   INITIALIZATION  ####  
//##################################################################################
// ###    INITIALIZATION      INITIALIZATION   INITIALIZATION   INITIALIZATION  ####  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###    INITIALIZATION      INITIALIZATION   INITIALIZATION   INITIALIZATION  ####  
//##################################################################################
// ###    INITIALIZATION      INITIALIZATION   INITIALIZATION   INITIALIZATION  ####  
//##################################################################################
// ###    INITIALIZATION      INITIALIZATION   INITIALIZATION   INITIALIZATION  ####  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###    INITIALIZATION      INITIALIZATION   INITIALIZATION   INITIALIZATION  ####  
//##################################################################################
// ###    INITIALIZATION      INITIALIZATION   INITIALIZATION   INITIALIZATION  ####  
//##################################################################################
// ###    INITIALIZATION      INITIALIZATION   INITIALIZATION   INITIALIZATION  ####  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###    INITIALIZATION      INITIALIZATION   INITIALIZATION   INITIALIZATION  ####  
//##################################################################################
// ###    INITIALIZATION      INITIALIZATION   INITIALIZATION   INITIALIZATION  ####  
//##################################################################################
// ###    INITIALIZATION      INITIALIZATION   INITIALIZATION   INITIALIZATION  ####  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###    INITIALIZATION      INITIALIZATION   INITIALIZATION   INITIALIZATION  ####  
//##################################################################################
// ###    INITIALIZATION      INITIALIZATION   INITIALIZATION   INITIALIZATION  ####  
//##################################################################################
// ###    INITIALIZATION      INITIALIZATION   INITIALIZATION   INITIALIZATION  ####  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//#################################################################################/
//****************************************************************\
//================================================================*\
//==== GetCurDevInitStatus FUNCTION ===============================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetCurDevInitStatus(USHORT usDevID)
{
	BYTE bIndexMainDevList;
	BYTE bIndexStructDevList;
	BOOLEAN fDevFound = FALSE;
	for(bIndexMainDevList = 0; bIndexMainDevList < 32; bIndexMainDevList++)
	{
		if(usDevList_GLOBAL[bIndexMainDevList] == usDevID) { fDevFound = TRUE; break; }
	}

	if(!fDevFound)
	{
		uiLastAnyError = ERR_DEV_NOT_FOUND;
		return FALSE;
	}

	bIndexStructDevList = bIndexMainDevList;
	if(structDevices[bIndexStructDevList]->usDevID == FALSE)
	{
		// UNUSUAL ERROR -- need to do something MORE about this
		uiLastAnyError = ERR_DEV_NOT_FOUND;
		return FALSE;
	}

	if(structDevices[bIndexStructDevList]->fInitialized == FALSE)
	{
		uiLastAnyError = ERR_DEV_NOT_INITIALIZED;
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DEV_NOT_INITIALIZED;
		return FALSE;
	}
	
	return TRUE;
}


//****************************************************************\
//==== PRIVATE FUNCTION ==========================================*\
//==== GetOsVer_PRIVATE FUNCTION ==================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetOsVer_PRIVATE()
{
	UINT uiDefOS_Code = 0;
	OSVERSIONINFO structOS_ver;
	structOS_ver.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&structOS_ver);
	uiDefOS_Code = LL_OS_UNKNOWN;
	if(structOS_ver.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS)
		uiDefOS_Code = uiDefOS_Code | LL_OS_Win95 | LL_OS_Win98 | LL_OS_WinME;
	else
		uiDefOS_Code = uiDefOS_Code | LL_OS_Win2k | LL_OS_WinXP | LL_OS_WinNT;
	
	uiOS_Code = uiDefOS_Code;

	if(uiDefOS_Code == LL_OS_UNKNOWN)
		return FALSE;

	return TRUE;
}


//****************************************************************\
//==== PRIVATE FUNCTION ==========================================*\
//==== LoadDLL_PRIVATE FUNCTION ===================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::LoadDLL_PRIVATE()
{

	//7-12-02
	GetOsVer_PRIVATE();

	while (TRUE)
	if(!hDLL)
	{
		if((uiOS_Code & LL_OS_Win95) || (uiOS_Code & LL_OS_Win95) || (uiOS_Code & LL_OS_Win95))
		{
			hDLL  = LoadLibrary( /*_T*/("LL_USB.DLL")); 
			if(!hDLL)
			{
				uiLastAnyError = ERR_DLL_NOT_FOUND;
				return FALSE;
			}
			break;
		}
		else
		{
			hDLL  = LoadLibrary( /*_T*/("LL_USB2k.DLL")); 
			if(!hDLL) 
			{
				uiLastAnyError = ERR_DLL_NOT_FOUND;
				return FALSE;
			}
			break;
		}
		uiLastAnyError = ERR_INVALID_OS;
		return FALSE;
	}
	uiLastAnyError = ERR_NO_ERROR;
	return TRUE;
}



//****************************************************************\
//==== PRIVATE FUNCTION ==========================================*\
//==== GetDevList_PRIVATE FUNCTION ================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetDevList_PRIVATE(USHORT* pausDevList, BYTE* _bNumDevices)
{
	if(!SP_GetRegDevList)
	{
		SP_GetRegDevList = (pSP_GetRegDevList)GetProcAddress( hDLL, /*_T*/("SP_GetRegDevList") );
		if(!SP_GetRegDevList) 
		{ 
			uiLastAnyError = ERR_DLL_FUNCTION_NOT_FOUND; 
			return FALSE; 
		}
	}

	UINT uiUnused = 0;
	if(!SP_GetRegDevList(pausDevList, uiUnused))
	{ uiLastAnyError = ERR_FAILED_IO; return FALSE; }

	BYTE bIndex = 0; BYTE bNumDevices = 0;
	for(;bIndex < 32; bIndex++)
	{
		if(pausDevList[bIndex] != 0)
			bNumDevices++;
	}
	*_bNumDevices = bNumDevices;
	return TRUE;
}



//****************************************************************\
//==== PRIVATE FUNCTION ==========================================*\
//==== Init_PRIVATE FUNCTION ======================================*>
//================================================================*/
/*****************************************************************/
// init multiple devices (threaded)
//BOOLEAN MyLL_USB::Init_PRIVATE(USHORT* pausDevList, BYTE* pabChans, DOUBLE* padblRates, UINT _uiOS_Code, BOOLEAN fThreaded)
BOOLEAN MyLL_USB::Init_PRIVATE(USHORT* pausDevList, BYTE* pabChans, DOUBLE* padblRates, BOOLEAN fThreaded)
{
	BYTE bIndex;

	//if(!LoadDLL_PRIVATE(_uiOS_Code)) return FALSE;
	if(!hDLL)
	if(!LoadDLL_PRIVATE()) return FALSE;

	// End any scans
	BOOLEAN fOkayToStartScan;
	BOOLEAN fScanning;
	for(BYTE bOuterIndex = 0; bOuterIndex < 32; bOuterIndex++)
	{
		if(pausDevList[bOuterIndex] != 0)
		{
			for(BYTE bInnerIndex = 0; bInnerIndex < 32; bInnerIndex++)
			{
				if(usDevList_GLOBAL[bInnerIndex] == pausDevList[bOuterIndex])
				{
					GetCurDevScanStatus(usDevList_GLOBAL[bInnerIndex], &fOkayToStartScan, &fScanning);
					if(fScanning)
					{
						EndScan(usDevList_GLOBAL[bInnerIndex]);
					}
				}
			}
		}
	}

	if(!SP_DisableDialog)
	{
		SP_DisableDialog = (pSP_DisableDialog)GetProcAddress( hDLL, /*_T*/("SP_DisableDialog") );
		if(!SP_DisableDialog) { uiLastAnyError = ERR_DLL_FUNCTION_NOT_FOUND; return FALSE; }
	}
	if(!SP_DisableDialog()) { uiLastAnyError = ERR_FAILED_IO; return FALSE; }


	if(!SP_InitAllDevices_Thread)
	{
		SP_InitAllDevices_Thread = (pSP_InitAllDevices_Thread)GetProcAddress( hDLL, /*_T*/("SP_InitAllDevices_Thread") );
		if(!SP_InitAllDevices_Thread) { uiLastAnyError = ERR_DLL_FUNCTION_NOT_FOUND; return FALSE; }
	}

	if(!SP_GetInitThreadStat)
	{
		SP_GetInitThreadStat = (pSP_GetInitThreadStat)GetProcAddress( hDLL, /*_T*/("SP_GetInitThreadStat") );
		if(!SP_GetInitThreadStat) { uiLastAnyError = ERR_DLL_FUNCTION_NOT_FOUND; return FALSE; }
	}
	if(!SP_GetLastInitDevAndRates)
	{
		SP_GetLastInitDevAndRates = (pSP_GetLastInitDevAndRates)GetProcAddress( hDLL, /*_T*/("SP_GetLastInitDevAndRates") );
		if(!SP_GetLastInitDevAndRates) { uiLastAnyError = ERR_DLL_FUNCTION_NOT_FOUND; return FALSE; }
	}
	if(!SP_GetLastInitStat)
	{
		SP_GetLastInitStat = (pSP_GetLastInitStat)GetProcAddress( hDLL, /*_T*/("SP_GetLastInitStat") );
		if(!SP_GetLastInitStat) { uiLastAnyError = ERR_DLL_FUNCTION_NOT_FOUND; return FALSE; }
	}


	BYTE bNumDevices = 1;

	BYTE bChanRequested[32];
	USHORT usDevOriginal[32];
	for(bIndex = 0; bIndex < 32; bIndex++)
	{
		usDevOriginal[bIndex] = pausDevList[bIndex];
		bChanRequested[bIndex] = pabChans[bIndex];
	}

	if(!SP_InitAllDevices_Thread(pausDevList, padblRates, FALSE))
	{
		uiLastAnyError = ERR_FAILED_IO;
		return FALSE;
	}

	while(TRUE)
	{
		if(SP_GetInitThreadStat() == FALSE)
		{
			break;
		}
	}

	SP_GetLastInitDevAndRates(pausDevList, padblRates);  

	if(pausDevList[0] == 0)
	{
		//NOTE: need to do something here
		//MessageBox(GetForegroundWindow(), "Failed to initialize any devices", " ERROR -------", 0);
		return FALSE;
	}

	for(bIndex = 0; bIndex < 32; bIndex++)
	{
		if(pausDevList[bIndex] == 0) break;

		//7-10-02 if(structDevices[bIndex] == NULL)
		if((DEVICES*)structDevices[bIndex] == NULL)
		{
			structDevices[bIndex] = new DEVICES;
			memset(structDevices[bIndex], 0, sizeof(DEVICES));
			fIsValidStructPntr[bIndex] = TRUE; 	//6-14-02
		}
		
		usDevList_GLOBAL[bIndex] = pausDevList[bIndex];
		structDevices[bIndex]->usDevID = pausDevList[bIndex];
		structDevices[bIndex]->dblRate = padblRates[bIndex];
		structDevices[bIndex]->fInitialized = TRUE;

		structDevices[bIndex]->bCurChan = pabChans[bIndex];

		fInitFlags[bIndex] = TRUE;
		for(BYTE bIndexInnerLoop = 0; bIndexInnerLoop < 32; bIndexInnerLoop++)
		{
			if(usDevOriginal[bIndexInnerLoop] == structDevices[bIndex]->usDevID)
			{
				structDevices[bIndex]->bCurChan = bChanRequested[bIndexInnerLoop];
				SetCurChan(structDevices[bIndex]->usDevID, structDevices[bIndex]->bCurChan);
				break;
			}
		}

	}

	fAnyDevInit = TRUE;

	return TRUE;
}



//****************************************************************\
//==== PRIVATE FUNCTION ==========================================*\
//==== Init_PRIVATE FUNCTION (non-threaded) =======================*>
//================================================================*/
/*****************************************************************/
// init multiple devices (non-threaded)
BOOLEAN MyLL_USB::Init_PRIVATE(USHORT* pausDevList, BYTE* pabChans, DOUBLE* padblRates)
{
	BYTE bIndex;
	uiLastAnyError = ERR_NO_ERROR;

	//if(!LoadDLL_PRIVATE(_uiOS_Code)) return FALSE;
	if(!hDLL)
	if(!LoadDLL_PRIVATE()) return FALSE;


	// End any scans
	BOOLEAN fOkayToStartScan;
	BOOLEAN fScanning;
	for(BYTE bOuterIndex = 0; bOuterIndex < 32; bOuterIndex++)
	{
		if(pausDevList[bOuterIndex] != 0)
		{
			for(BYTE bInnerIndex = 0; bInnerIndex < 32; bInnerIndex++)
			{
				if(usDevList_GLOBAL[bInnerIndex] == pausDevList[bOuterIndex])
				{
					GetCurDevScanStatus(usDevList_GLOBAL[bInnerIndex], &fOkayToStartScan, &fScanning);
					if(fScanning)
					{
						EndScan(usDevList_GLOBAL[bInnerIndex]);
					}
				}
			}
		}
	}

	if(!SP_InitAllDevices)
	{
		SP_InitAllDevices = (pSP_InitAllDevices)GetProcAddress( hDLL, /*_T*/("SP_InitAllDevices") );
		if(!SP_InitAllDevices) 
		{ 
			uiLastAnyError = ERR_DLL_FUNCTION_NOT_FOUND;
			return FALSE; 
		}
	}

	if(!SP_DisableDialog)
	{
		SP_DisableDialog = (pSP_DisableDialog)GetProcAddress( hDLL, /*_T*/("SP_DisableDialog") );
		if(!SP_DisableDialog) 
		{ 
			uiLastAnyError = ERR_DLL_FUNCTION_NOT_FOUND;
			return FALSE; 
		}
	}

	if(!SP_DisableDialog())
	{
		uiLastAnyError = ERR_FAILED_IO;
		return FALSE;
	}

	BYTE bNumDevices = 1;

	BYTE bChanRequested[32];
	USHORT usDevOriginal[32];
	for(bIndex = 0; bIndex < 32; bIndex++)
	{
		usDevOriginal[bIndex] = pausDevList[bIndex];
		bChanRequested[bIndex] = pabChans[bIndex];
	}

	if(!SP_InitAllDevices(pausDevList, &bNumDevices, padblRates, FALSE))
	{
		uiLastAnyError = ERR_FAILED_IO;
		return FALSE;
	}

	if(pausDevList[0] == 0)
	{
		//NOTE: need to do something here
		//MessageBox(GetForegroundWindow(), "Failed to initialize any devices", " ERROR -------", 0);
		return FALSE;
	}

	for(bIndex = 0; bIndex < 32; bIndex++)
	{
		if(pausDevList[bIndex] == 0) break;

		if(!fIsValidStructPntr[bIndex])
		if(!structDevices[bIndex])
		{
			structDevices[bIndex] = new DEVICES;
			memset(structDevices[bIndex], 0, sizeof(DEVICES));
			fIsValidStructPntr[bIndex] = TRUE;
		}
		
		usDevList_GLOBAL[bIndex] = pausDevList[bIndex];
		structDevices[bIndex]->usDevID = pausDevList[bIndex];
		structDevices[bIndex]->dblRate = padblRates[bIndex];
		structDevices[bIndex]->fInitialized = TRUE;
		structDevices[bIndex]->bCurChan = pabChans[bIndex];

		fInitFlags[bIndex] = TRUE;
		for(BYTE bIndexInnerLoop = 0; bIndexInnerLoop < 32; bIndexInnerLoop++)
		{
			if(usDevOriginal[bIndexInnerLoop] == structDevices[bIndex]->usDevID)
			{
				structDevices[bIndex]->bCurChan = bChanRequested[bIndexInnerLoop];
				SetCurChan(structDevices[bIndex]->usDevID, structDevices[bIndex]->bCurChan);
				break;
			}
		}

	}

	fAnyDevInit = TRUE;

	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== Init FUNCTION ==============================================*>
//================================================================*/
/*****************************************************************/
// init single device - first found, use defaults of 
// channel 0 and 100Hz.
BOOLEAN MyLL_USB::Init_SP()
{
	if(!hDLL)
	if(!LoadDLL_PRIVATE()) return FALSE;

	BYTE bNumDevices = 0; BYTE bIndex; USHORT usDevID = 0; BOOLEAN fAnyDevFound = FALSE;

	USHORT usDevList[32]; memset(usDevList, 0, sizeof(usDevList));
	USHORT* pausDevList = usDevList;
	if(!GetDevList_PRIVATE(pausDevList, &bNumDevices)) return FALSE;


	if(!bNumDevices)
	{ uiLastAnyError = ERR_DEV_NOT_FOUND; return FALSE; }

	USHORT bNewDevList[32];
	memset(bNewDevList, 0, sizeof(bNewDevList));
	BYTE bNewIndex = 0;

	for(bIndex = 0; bIndex < 32; bIndex++)
	{
		if(pausDevList[bIndex] != 0)
		{
			if((pausDevList[bIndex] & 0x8000) == 0)
			{
				bNewDevList[bNewIndex] = pausDevList[bIndex];
				bNewIndex++;
				//usDevID = pausDevList[bIndex];
				fAnyDevFound = TRUE;
				//break;
			}
		}
	}

	if(!fAnyDevFound)
	{
		uiLastAnyError = ERR_DEV_NOT_FOUND;
		return FALSE;
	}

	usDevID = bNewDevList[0];
	
	memset(usDevList, 0, sizeof(usDevList)); 
	usDevList[0] = usDevID;
	BYTE abChans[32]; 
	memset(abChans, 0, sizeof(abChans)); 
	abChans[0] = 1; 
	BYTE* pabChans = abChans;
	DOUBLE adblRates[32]; 
	memset(adblRates, 0, sizeof(adblRates)); 
	adblRates[0] = 100; 
	DOUBLE* padblRates = adblRates;
	DOUBLE dblRate = 100;

	BOOLEAN fSuccessInit = 0;
	for(bIndex = 0; bIndex < bNewIndex; bIndex++)
	{
		if(Init_PRIVATE (pausDevList[0], pabChans[0],  &dblRate))
		{
			break;
			fSuccessInit = TRUE;
		}
		pausDevList[0] = bNewDevList[bIndex];
		abChans[0] = 1; 
		adblRates[0] = 100; 
	}

	return TRUE;
}










//****************************************************************\
//==== PRIVATE FUNCTION ==========================================*\
//==== Init_PRIVATE FUNCTION (non-threaded, single device) ========*>
//================================================================*/
/*****************************************************************/
// NON-Threaded, single device version
BOOLEAN MyLL_USB::Init_PRIVATE(USHORT usDevID, BYTE bChan, DOUBLE* dblRate)
{
	if(!hDLL)
	if(!LoadDLL_PRIVATE()) 
	{
		return FALSE;
	}

	BYTE bIndex;
	uiLastAnyError = ERR_NO_ERROR;

	BOOLEAN fDLL_LoadSuccess = FALSE;
	if(!hDLL)
	{
		if((uiOS_Code & LL_OS_Win95) || (uiOS_Code & LL_OS_Win95) || (uiOS_Code & LL_OS_Win95))
		{
			hDLL  = LoadLibrary( /*_T*/("LL_USB.DLL")); 
			if(!hDLL)
			{
				uiLastAnyError = ERR_DLL_NOT_FOUND;
				return FALSE;
			}
			else fDLL_LoadSuccess = TRUE;
		}
		else
		{
			hDLL  = LoadLibrary( /*_T*/("LL_USB2k.DLL")); 
			if(!hDLL) 
			{
				uiLastAnyError = ERR_DLL_NOT_FOUND;
				return FALSE;
			}
			else fDLL_LoadSuccess = TRUE;
		}
		if(!fDLL_LoadSuccess)
		{
			uiLastAnyError = ERR_INVALID_OS;
			return FALSE;
		}
	}

	BYTE bIndexStructDevList;
	if(!GetDevListIndex(usDevID, &bIndexStructDevList)) 
	{ 
		bIndexStructDevList = 0; 
	}
	else
	{
		BOOLEAN fOkayToStartScan; BOOLEAN fScanning;
		GetCurDevScanStatus(usDevList_GLOBAL[bIndexStructDevList], &fOkayToStartScan, &fScanning);
		if(fScanning)
		{ EndScan(usDevList_GLOBAL[bIndexStructDevList]); }
	}

	if(!SP_InitAllDevices)
	{
		SP_InitAllDevices = (pSP_InitAllDevices)GetProcAddress( hDLL, /*_T*/("SP_InitAllDevices") );
		if(!SP_InitAllDevices) 
		{ 
			uiLastAnyError = ERR_DLL_FUNCTION_NOT_FOUND;
			return FALSE; 
		}
	}

	if(!SP_DisableDialog)
	{
		SP_DisableDialog = (pSP_DisableDialog)GetProcAddress( hDLL, /*_T*/("SP_DisableDialog") );
		if(!SP_DisableDialog) 
		{ 
			uiLastAnyError = ERR_DLL_FUNCTION_NOT_FOUND;
			return FALSE; 
		}
	}

	if(!SP_DisableDialog())
	{
		uiLastAnyError = ERR_FAILED_IO;
		return FALSE;
	}

	BYTE bNumDevices = 1;
	USHORT usDevList_Local[32]; memset(usDevList_Local, 0, sizeof(usDevList_Local));
	BYTE bChans_Local[32]; memset(bChans_Local, 0, sizeof(bChans_Local));
	DOUBLE dblDevRates_Local[32]; memset(dblDevRates_Local, 0, sizeof(dblDevRates_Local));
	usDevList_Local[0] = usDevID;
	bChans_Local[0] = bChan;
	dblDevRates_Local[0] = dblRate[0];

	if(!SP_InitAllDevices(usDevList_Local, &bNumDevices, dblDevRates_Local, FALSE))
	{
		uiLastAnyError = ERR_FAILED_IO;
		return FALSE;
	}

	if(usDevList_Local[0] == 0)
	{
		//NOTE: need to do something here
		//MessageBox(GetForegroundWindow(), "Failed to initialize any devices", " ERROR -------", 0);
		return FALSE;
	}

	if(usDevList_Local[0] != 0)
	for(bIndex = 0; bIndex < 32; bIndex++)
	{
		if(!fIsValidStructPntr[bIndex])
		if(!structDevices[bIndex])
		{
			structDevices[bIndex] = new DEVICES;
			memset(structDevices[bIndex], 0, sizeof(DEVICES));
			fIsValidStructPntr[bIndex] = TRUE;
		}
		
		usDevList_GLOBAL[bIndex] = usDevList_Local[0];
		structDevices[bIndex]->usDevID = usDevList_Local[0];
		structDevices[bIndex]->dblRate = dblDevRates_Local[0];
		structDevices[bIndex]->fInitialized = TRUE;
		structDevices[bIndex]->bCurChan = bChans_Local[0];

		fInitFlags[bIndex] = TRUE;
		SetCurChan(structDevices[bIndex]->usDevID, structDevices[bIndex]->bCurChan);
		fAnyDevInit = TRUE;
		break;
	}

	if(!fAnyDevInit) 
		return FALSE;
	else
		return TRUE;
}



//#################################################################################\
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## SINGLE CONVERSION   CHANNEL   DIGITAL I/O   RATE   CALIBRATION   STATUS ######  
//##################################################################################
// ## SINGLE CONVERSION   CHANNEL   DIGITAL I/O   RATE   CALIBRATION   STATUS ######  
//##################################################################################
// ## SINGLE CONVERSION   CHANNEL   DIGITAL I/O   RATE   CALIBRATION   STATUS ######  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## SINGLE CONVERSION   CHANNEL   DIGITAL I/O   RATE   CALIBRATION   STATUS ######  
//##################################################################################
// ## SINGLE CONVERSION   CHANNEL   DIGITAL I/O   RATE   CALIBRATION   STATUS ######  
//##################################################################################
// ## SINGLE CONVERSION   CHANNEL   DIGITAL I/O   RATE   CALIBRATION   STATUS ######  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## SINGLE CONVERSION   CHANNEL   DIGITAL I/O   RATE   CALIBRATION   STATUS ######  
//##################################################################################
// ## SINGLE CONVERSION   CHANNEL   DIGITAL I/O   RATE   CALIBRATION   STATUS ######  
//##################################################################################
// ## SINGLE CONVERSION   CHANNEL   DIGITAL I/O   RATE   CALIBRATION   STATUS ######  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## SINGLE CONVERSION   CHANNEL   DIGITAL I/O   RATE   CALIBRATION   STATUS ######  
//##################################################################################
// ## SINGLE CONVERSION   CHANNEL   DIGITAL I/O   RATE   CALIBRATION   STATUS ######  
//##################################################################################
// ## SINGLE CONVERSION   CHANNEL   DIGITAL I/O   RATE   CALIBRATION   STATUS ######  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## SINGLE CONVERSION   CHANNEL   DIGITAL I/O   RATE   CALIBRATION   STATUS ######  
//##################################################################################
// ## SINGLE CONVERSION   CHANNEL   DIGITAL I/O   RATE   CALIBRATION   STATUS ######  
//##################################################################################
// ## SINGLE CONVERSION   CHANNEL   DIGITAL I/O   RATE   CALIBRATION   STATUS ######  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## SINGLE CONVERSION   CHANNEL   DIGITAL I/O   RATE   CALIBRATION   STATUS ######  
//##################################################################################
// ## SINGLE CONVERSION   CHANNEL   DIGITAL I/O   RATE   CALIBRATION   STATUS ######  
//##################################################################################
// ## SINGLE CONVERSION   CHANNEL   DIGITAL I/O   RATE   CALIBRATION   STATUS ######  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//#################################################################################/
//10-14-02
//****************************************************************\
//================================================================*\
//==== WriteWhileScanning_SP FUNCTION ================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::WriteWhileScanning_SP(BYTE bCmnd, BYTE bArg, UINT* puiCurWriteStat)
{
	USHORT usDevID;
	if(!GetZeroIndexDev_PRIVATE(&usDevID)) return FALSE;
	if(!WriteWhileScanning(usDevID, bCmnd,bArg, puiCurWriteStat)) return FALSE;
	return TRUE;
}
//****************************************************************\
//================================================================*\
//==== WriteWhileScanning FUNCTION ================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::WriteWhileScanning(USHORT usDevID, BYTE bCmnd, BYTE bArg, UINT* _puiCurWriteStat)
{
	BYTE bIndexStructDevList;
	if(!GetDevListIndex(usDevID, &bIndexStructDevList)) { uiLastAnyError = ERR_DEV_NOT_FOUND; return FALSE; }
	if(!SP_WriteWhileScanning)
	{
		SP_WriteWhileScanning = (pSP_WriteWhileScanning)GetProcAddress( hDLL, /*_T*/("SP_WriteWhileScanning") );
		if(!SP_WriteWhileScanning) 
		{ 
			uiLastAnyError = ERR_DLL_FUNCTION_NOT_FOUND;
			structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DLL_FUNCTION_NOT_FOUND;
			return FALSE; 
		}
	}

	UINT puiCurWriteStat = 0;
	if(!WriteWhileScanning(usDevID, bCmnd,bArg, &puiCurWriteStat))
	{
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_FAILED_IO;
		uiLastAnyError = ERR_FAILED_IO;
		return FALSE; 
	}
	*_puiCurWriteStat = puiCurWriteStat;

	return TRUE;
}




//****************************************************************\
//================================================================*\
//==== SetCurChan FUNCTION ========================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::SetCurChan_SP(BYTE bChan)
{
	USHORT usDevID;
	if(!GetZeroIndexDev_PRIVATE(&usDevID)) return FALSE;
	if(!SetCurChan(usDevID, bChan)) return FALSE;
	return TRUE;
}


//****************************************************************\
//================================================================*\
//==== SetCurChan FUNCTION ========================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::SetCurChan(USHORT usDevID, BYTE bChan)
{
	BYTE bIndexStructDevList;
	if(!GetDevListIndex(usDevID, &bIndexStructDevList)) { uiLastAnyError = ERR_DEV_NOT_FOUND; return FALSE; }

	if(!SP_SendChan)
	{
		SP_SendChan = (pSP_SendChan)GetProcAddress( hDLL, /*_T*/("SP_SendChan") );
		if(!SP_SendChan) 
		{ 
			uiLastAnyError = ERR_DLL_FUNCTION_NOT_FOUND;
			structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DLL_FUNCTION_NOT_FOUND;
			return FALSE; 
		}
	}

	BYTE bLastDigin_UNUSED;
	if(!SP_SendChan(usDevID, bChan, &bLastDigin_UNUSED))
	{
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_FAILED_IO;
		uiLastAnyError = ERR_FAILED_IO;
		return FALSE; 
	}


	return TRUE;
}


//****************************************************************\
//================================================================*\
//==== GetCurChan FUNCTION ========================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetCurChan(BYTE* pbChan)
{
	USHORT usDevID;
	if(!GetZeroIndexDev_PRIVATE(&usDevID)) return FALSE;
	if(!GetCurChan(usDevID, pbChan)) return FALSE;
	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== GetCurChan FUNCTION ========================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetCurChan(USHORT usDevID, BYTE* pbCurChan)
{
	BYTE bIndexStructDevList;
	if(!GetDevListIndex(usDevID, &bIndexStructDevList)) { uiLastAnyError = ERR_DEV_NOT_FOUND; return FALSE; }

	*pbCurChan = structDevices[bIndexStructDevList]->bCurChan;
	return TRUE;
}


//****************************************************************\
//================================================================*\
//==== Calibrate FUNCTION ========================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::Calibrate_SP()
{
	USHORT usDevID;
	if(!GetZeroIndexDev_PRIVATE(&usDevID)) return FALSE;
	if(!Calibrate(usDevID)) return FALSE;
	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== Calibrate FUNCTION =========================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::Calibrate(USHORT usDevID)
{
	BYTE bIndexStructDevList;
	if(!GetDevListIndex(usDevID, &bIndexStructDevList)) { uiLastAnyError = ERR_DEV_NOT_FOUND; return FALSE; }

	if(!SP_SystemCalibration)
	{
		SP_SystemCalibration = (pSP_SystemCalibration)GetProcAddress( hDLL, /*_T*/("SP_SystemCalibration") );
		if(!SP_SystemCalibration) 
		{ 
			uiLastAnyError = ERR_DLL_FUNCTION_NOT_FOUND;
			structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DLL_FUNCTION_NOT_FOUND;
			return FALSE; 
		}
	}

	if(!SP_SystemCalibration(usDevID, structDevices[bIndexStructDevList]->bCurChan))
	{
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_FAILED_IO;
		uiLastAnyError = ERR_FAILED_IO;
		return FALSE; 
	}


	return TRUE;
}

//****************************************************************\
//================================================================*\
//==== GetOneCount FUNCTION =======================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetOneCount(USHORT usDevID, UINT* uiRawCount)
{
	BYTE bIndexStructDevList;
	if(!GetDevListIndex(usDevID, &bIndexStructDevList)) 
	{ 
		uiLastAnyError = ERR_DEV_NOT_FOUND; 
		return FALSE; 
	}

	BOOLEAN fOkayToStartScan;
	BOOLEAN fScanning;
	GetCurDevScanStatus(usDevID, &fOkayToStartScan, &fScanning);
	if(fScanning)
	{
		uiLastAnyError = ERR_DEV_BUSY_SCANNING; 
		return FALSE;
	}

	if(!SP_GetOneConversion) 
	{ 
		SP_GetOneConversion = (pSP_GetOneConversion)GetProcAddress( hDLL, /*_T*/("SP_GetOneConversion") ); 
		if(!SP_GetOneConversion) 
		{ 
			uiLastAnyError = ERR_DLL_FUNCTION_NOT_FOUND;
			structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DLL_FUNCTION_NOT_FOUND;
			return FALSE; 
		} 
	}

	BYTE bLastDiginTemp = 0; 
	if(!SP_GetOneConversion(usDevID, uiRawCount, structDevices[bIndexStructDevList]->bCurChan, &bLastDiginTemp))
	{
		uiLastAnyError = ERR_FAILED_IO;
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_FAILED_IO;
		return FALSE; 
	}

	bLastDiginTemp ^= 255;
	structDevices[bIndexStructDevList]->bLastDigin = bLastDiginTemp;

	return TRUE;
}




//****************************************************************\
//================================================================*\
//==== GetOneVoltage FUNCTION =====================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetOneVoltage_SP(DOUBLE* pdblVoltage)
{
	USHORT usDevID;
	if(!GetZeroIndexDev_PRIVATE(&usDevID)) return FALSE;
	if(!GetOneVoltage(usDevID, pdblVoltage)) return FALSE;
	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== GetOneVoltage FUNCTION =====================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetOneVoltage(USHORT usDevID, DOUBLE* pdblVoltage)
{
	BYTE bIndexStructDevList;
	if(!GetDevListIndex(usDevID, &bIndexStructDevList)) 
	{ 
		uiLastAnyError = ERR_DEV_NOT_FOUND; 
		return FALSE; 
	}

	BOOLEAN fOkayToStartScan;
	BOOLEAN fScanning;
	GetCurDevScanStatus(usDevID, &fOkayToStartScan, &fScanning);
	if(fScanning)
	{
		uiLastAnyError = ERR_DEV_BUSY_SCANNING; 
		return FALSE;
	}

	if(!SP_GetOneConversion) 
	{ 
		SP_GetOneConversion = (pSP_GetOneConversion)GetProcAddress( hDLL, /*_T*/("SP_GetOneConversion") ); 
		if(!SP_GetOneConversion) 
		{ 
			uiLastAnyError = ERR_DLL_FUNCTION_NOT_FOUND;
			structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DLL_FUNCTION_NOT_FOUND;
			return FALSE; 
		} 
	}

	UINT uiRawCount;
	BYTE bLastDiginTemp = 0; 
	if(!SP_GetOneConversion(usDevID, &uiRawCount, structDevices[bIndexStructDevList]->bCurChan, &bLastDiginTemp))
	{
		uiLastAnyError = ERR_FAILED_IO;
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_FAILED_IO;
		return FALSE; 
	}

	bLastDiginTemp ^= 255;
	structDevices[bIndexStructDevList]->bLastDigin = bLastDiginTemp;

	DOUBLE dblVoltage = ((INT)uiRawCount - 8388608) * 0.00000059604645;
	*pdblVoltage = dblVoltage;

	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== GetOneVoltage FUNCTION =====================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetOneVoltage(USHORT usDevID, DOUBLE* pdblVoltage, DOUBLE dblRange)
{
	BYTE bIndexStructDevList;
	if(!GetDevListIndex(usDevID, &bIndexStructDevList)) 
	{ 
		uiLastAnyError = ERR_DEV_NOT_FOUND; 
		return FALSE; 
	}

	BOOLEAN fOkayToStartScan;
	BOOLEAN fScanning;
	GetCurDevScanStatus(usDevID, &fOkayToStartScan, &fScanning);
	if(fScanning)
	{
		uiLastAnyError = ERR_DEV_BUSY_SCANNING; 
		return FALSE;
	}

	if(!SP_GetOneConversion) 
	{ 
		SP_GetOneConversion = (pSP_GetOneConversion)GetProcAddress( hDLL, /*_T*/("SP_GetOneConversion") ); 
		if(!SP_GetOneConversion) 
		{ 
			uiLastAnyError = ERR_DLL_FUNCTION_NOT_FOUND;
			structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DLL_FUNCTION_NOT_FOUND;
			return FALSE; 
		} 
	}

	UINT uiRawCount;
	BYTE bLastDiginTemp = 0; 
	if(!SP_GetOneConversion(usDevID, &uiRawCount, structDevices[bIndexStructDevList]->bCurChan, &bLastDiginTemp))
	{
		uiLastAnyError = ERR_FAILED_IO;
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_FAILED_IO;
		return FALSE; 
	}

	bLastDiginTemp ^= 255;
	structDevices[bIndexStructDevList]->bLastDigin = bLastDiginTemp;

	DOUBLE dblRawCount = (DOUBLE)uiRawCount;
	DOUBLE dblVoltage = (dblRawCount - 8388608) * ((dblRange / (DOUBLE)16777215) * 2);

	*pdblVoltage = dblVoltage;

	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== SendAnalogOut FUNCTION =====================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::SendAnalogOut(BYTE bDAC, DOUBLE dblVoltage)
{
	USHORT usDevID;
	if(!GetZeroIndexDev_PRIVATE(&usDevID)) return FALSE;
	if(!SendAnalogOut(usDevID, bDAC, dblVoltage)) return FALSE;
	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== SendAnalogOut FUNCTION =====================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::SendAnalogOut(USHORT usDevID, BYTE bDAC, DOUBLE dblVoltage)
{
	BYTE bIndexStructDevList;
	if(!GetDevListIndex(usDevID, &bIndexStructDevList)) 
	{ 
		uiLastAnyError = ERR_DEV_NOT_FOUND; 
		return FALSE; 
	}

	BOOLEAN fOkayToStartScan;
	BOOLEAN fScanning;
	GetCurDevScanStatus(usDevID, &fOkayToStartScan, &fScanning);
	if(fScanning)
	{
		uiLastAnyError = ERR_DEV_BUSY_SCANNING; 
		return FALSE;
	}

	if(usDevID < 4990)
	{
		uiLastAnyError = ERR_WRONG_DEV_TYPE; 
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_WRONG_DEV_TYPE;
		return FALSE;
	}

	if(!SP_SendDAC) 
	{ 
		SP_SendDAC = (pSP_SendDAC)GetProcAddress( hDLL, /*_T*/("SP_SendDAC") ); 
		if(!SP_SendDAC) 
		{ 
			uiLastAnyError = ERR_DLL_FUNCTION_NOT_FOUND;
			structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DLL_FUNCTION_NOT_FOUND;
			return FALSE; 
		} 
	}

	BYTE bReserved = 0;
	if(!SP_SendDAC(usDevID, dblVoltage, bDAC, &bReserved))
	{
		uiLastAnyError = ERR_FAILED_IO;
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_FAILED_IO;
		return FALSE; 
	}

	return TRUE;
}


//****************************************************************\
//================================================================*\
//==== SendDigitalOutput FUNCTION =================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::SendDigitalOutput_SP(BYTE bDigOut)
{
	USHORT usDevID;
	if(!GetZeroIndexDev_PRIVATE(&usDevID)) return FALSE;
	if(!SendDigitalOutput(usDevID, bDigOut)) return FALSE;
	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== SendDigitalOutput FUNCTION =================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::SendDigitalOutput(USHORT usDevID, BYTE bDigOut)
{
	BYTE bIndexStructDevList;
	if(!GetDevListIndex(usDevID, &bIndexStructDevList)) 
	{ 
		uiLastAnyError = ERR_DEV_NOT_FOUND; 
		return FALSE; 
	}

	if(!SP_SendDigOut) 
	{ 
		SP_SendDigOut = (pSP_SendDigOut)GetProcAddress( hDLL, /*_T*/("SP_SendDigOut") ); 
		if(!SP_SendDigOut) 
		{ 
			uiLastAnyError = ERR_FAILED_IO;
			structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DLL_FUNCTION_NOT_FOUND;
			return FALSE; 
		} 
	}

	BYTE bLastDigin_UNUSED;
	if(!SP_SendDigOut(usDevID, bDigOut, &bLastDigin_UNUSED))
	{
		uiLastAnyError = ERR_FAILED_IO;
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_FAILED_IO;
		return FALSE; 
	}

	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== GetDigitalInput FUNCTION ===================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetDigitalInput_SP(BYTE* pbDigInVal)
{
	USHORT usDevID;
	if(!GetZeroIndexDev_PRIVATE(&usDevID)) return FALSE;
	if(!GetDigitalInput(usDevID, pbDigInVal)) return FALSE;
	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== GetCurrentDigitalInput FUNCTION ============================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetDigitalInput(USHORT usDevID, BYTE* pbDigInVal)
{
	BYTE bIndexStructDevList;
	if(!GetDevListIndex(usDevID, &bIndexStructDevList)) 
	{ 
		uiLastAnyError = ERR_DEV_NOT_FOUND; 
		return FALSE; 
	}

	BOOLEAN fOkayToStartScan;
	BOOLEAN fScanning;
	GetCurDevScanStatus(usDevID, &fOkayToStartScan, &fScanning);
	if(fScanning)
	{
		BYTE bValue = structDevices[bIndexStructDevList]->ScanObject.SO_bDigitalInput;
		*pbDigInVal =  bValue;
		return TRUE;
	}

	// Current digital input always returned with a read of the device
	//  so I'll just do any function that does a read.
	UINT uiRawCount_UNUSED;
	if(!GetOneCount(usDevID, &uiRawCount_UNUSED))
	{
		// NOTE: The call above will handle the setting of the error codes
		return FALSE;
	}
	*pbDigInVal = structDevices[bIndexStructDevList]->bLastDigin;
	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== GetDigitalInput FUNCTION ===================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::ChangeCurDevRate_SP(DOUBLE* pdblRate)
{
	USHORT usDevID;
	if(!GetZeroIndexDev_PRIVATE(&usDevID)) return FALSE;
	if(!ChangeCurDevRate(usDevID, pdblRate)) return FALSE;
	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== ChangeCurDevRate FUNCTION ==================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::ChangeCurDevRate(USHORT usDevID, DOUBLE* pdblRate)
{
	BYTE bIndexStructDevList;
	if(!GetDevListIndex(usDevID, &bIndexStructDevList)) 
	{ 
		uiLastAnyError = ERR_DEV_NOT_FOUND; 
		return FALSE; 
	}

	BOOLEAN fOkayToStartScan;
	BOOLEAN fScanning;
	GetCurDevScanStatus(usDevID, &fOkayToStartScan, &fScanning);
	if(fScanning)
	{
		uiLastAnyError = ERR_DEV_BUSY_SCANNING; 
		return FALSE;
	}

	if(!SP_SendRate) 
	{ 
		SP_SendRate = (pSP_SendRate)GetProcAddress( hDLL, /*_T*/("SP_SendRate") ); 
		if(!SP_SendRate) 
		{ 
			uiLastAnyError = ERR_FAILED_IO;
			structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DLL_FUNCTION_NOT_FOUND;
			return FALSE; 
		} 
	}

	if(!SP_SendRate(pdblRate, usDevID))
	{
		uiLastAnyError = ERR_FAILED_IO;
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_FAILED_IO;

		return FALSE; 
	}

	return TRUE;
}


//****************************************************************\
//================================================================*\
//==== GetDevStatus FUNCTION ======================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetDevStatus_SP(UINT* puiConnectionStat, UINT* puiPowerStat)
{
	USHORT usDevID;
	if(!GetZeroIndexDev_PRIVATE(&usDevID)) return FALSE;
	if(!GetDevStatus(usDevID, puiConnectionStat, puiPowerStat)) return FALSE;
	return TRUE;
}




//****************************************************************\
//================================================================*\
//==== GetDevStatus FUNCTION ======================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetDevStatus(USHORT usDevID, UINT* puiConnectionStat, UINT* puiPowerStat)
{
	BYTE bIndexStructDevList;
	if(!GetDevListIndex(usDevID, &bIndexStructDevList)) 
	{ 
		uiLastAnyError = ERR_DEV_NOT_FOUND; 
		return FALSE; 
	}

	BOOLEAN fOkayToStartScan;
	BOOLEAN fScanning;
	GetCurDevScanStatus(usDevID, &fOkayToStartScan, &fScanning);
	if(fScanning)
	{
		uiLastAnyError = ERR_DEV_BUSY_SCANNING; 
		return FALSE;
	}

	if(!SP_GetDevStat) 
	{ 
		SP_GetDevStat = (pSP_GetDevStat)GetProcAddress( hDLL, /*_T*/("SP_GetDevStat") ); 
		if(!SP_GetDevStat) 
		{ 
			uiLastAnyError = ERR_FAILED_IO;
			structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DLL_FUNCTION_NOT_FOUND;
			return FALSE; 
		} 
	}

	if(!SP_GetDevStat(usDevID, puiConnectionStat))
	{
		uiLastAnyError = ERR_FAILED_IO;
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_FAILED_IO;
		return FALSE; 
	}

	if(!SP_CheckPower) 
	{ 
		SP_CheckPower = (pSP_CheckPower)GetProcAddress( hDLL, /*_T*/("SP_CheckPower") ); 
		if(!SP_CheckPower) 
		{ 
			uiLastAnyError = ERR_FAILED_IO;
			structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DLL_FUNCTION_NOT_FOUND;
			return FALSE; 
		} 
	}

	BYTE bLastDigin;
	if(!SP_CheckPower(usDevID, structDevices[bIndexStructDevList]->bCurChan, &bLastDigin, puiPowerStat))
	{
		uiLastAnyError = ERR_FAILED_IO;
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_FAILED_IO;
		return FALSE; 
	}


	bLastDigin ^= 255;
	structDevices[bIndexStructDevList]->bLastDigin = bLastDigin;

	return TRUE;
}


//#################################################################################\
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//#################################################################################/
//****************************************************************\
//================================================================*\
//==== GetCurDevScanStatus FUNCTION ===============================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetCurDevScanStatus_SP(BOOLEAN* pfOkayToStartScan, BOOLEAN* pfScanning)
{
	USHORT usDevID;
	if(!GetZeroIndexDev_PRIVATE(&usDevID)) return FALSE;
	if(!GetCurDevScanStatus(usDevID, pfOkayToStartScan, pfScanning)) return FALSE;
	return TRUE;
}




//****************************************************************\
//================================================================*\
//==== GetCurDevScanStatus FUNCTION ===============================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetCurDevScanStatus(USHORT usDevID, BOOLEAN* pfOkayToStartScan, BOOLEAN* pfScanning)
{
	BYTE bIndexStructDevList;
	if(!GetDevListIndex(usDevID, &bIndexStructDevList)) 
	{ 
		uiLastAnyError = ERR_DEV_NOT_FOUND; 
		*pfOkayToStartScan = FALSE; *pfScanning = FALSE;
		return FALSE; 
	}

	if(!GetCurDevInitStatus(usDevID))
	{
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DEV_NOT_INITIALIZED;
		uiLastAnyError = ERR_DEV_NOT_INITIALIZED;
		*pfOkayToStartScan = FALSE; *pfScanning = FALSE;
		return FALSE;
	}
	
	if(structDevices[bIndexStructDevList]->fScanning == FALSE) 
	{
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DEV_NOT_SCANNING;
		uiLastAnyError = ERR_DEV_NOT_SCANNING;
		*pfOkayToStartScan = TRUE; *pfScanning = FALSE;
	}
	else
	{ *pfOkayToStartScan = FALSE; *pfScanning = TRUE; }
	
	return TRUE;
}


//****************************************************************\
//================================================================*\
//==== StartScan_ALL_TYPES FUNCTION ===============================*>
//================================================================*/
//================================================================*\
//==== StartScan_ALL_TYPES FUNCTION ===============================*>
//================================================================*/
//================================================================*\
//==== StartScan_ALL_TYPES FUNCTION ===============================*>
//================================================================*/
//================================================================*\
//==== StartScan_ALL_TYPES FUNCTION ===============================*>
//================================================================*/
// PRIVATE FUNCTION    PRIVATE FUNCTION    PRIVATE FUNCTION =======\
// PRIVATE FUNCTION    PRIVATE FUNCTION    PRIVATE FUNCTION =======/
/*****************************************************************/
BOOLEAN MyLL_USB::StartScan_ALL_TYPES(BYTE bNumDevices, USHORT* pausDevIDList, BYTE* pabScanTypeList, 
									  BYTE* pabNumChansList, BYTE* pabScanStartedList)
{
	BYTE bIndexStructDevList;
	BYTE bAnyIndex;
	BYTE bNumDevices_LOCAL = bNumDevices;

	if(!DLL_StartScan) 
	{ 
		DLL_StartScan = (pDLL_StartScan)GetProcAddress( hDLL, /*_T*/("DLL_StartScan_DIO") ); 
		if(!DLL_StartScan) 
		{ 
			uiLastAnyError = ERR_DLL_FUNCTION_NOT_FOUND;
			for(bAnyIndex = 0; bAnyIndex < bNumDevices_LOCAL; bAnyIndex++)
			{ structDevices[bAnyIndex]->uiLastErrorCodeThisDev = ERR_DLL_FUNCTION_NOT_FOUND; }
			return FALSE; 
		} 
	}

	BOOLEAN fOkayToStartScan;
	BOOLEAN fScanning;
	BOOLEAN fAnyDevStartedScanning;
	BYTE bNumDevStartedScan = 0;
	BYTE bScanType_Local;

	for(bAnyIndex = 0; bAnyIndex < bNumDevices_LOCAL; bAnyIndex++)
	{ pabScanStartedList[bAnyIndex] = 0; }

	for(bAnyIndex = 0; bAnyIndex < bNumDevices_LOCAL; bAnyIndex++)
	{
		if(!GetDevListIndex(pausDevIDList[bAnyIndex], &bIndexStructDevList)) 
		{ 
			uiLastAnyError = ERR_DEV_NOT_FOUND; 
			pausDevIDList[bAnyIndex] = 0;
			continue;
		}

		if(!GetCurDevInitStatus(pausDevIDList[bAnyIndex]))
		{ continue; }

		GetCurDevScanStatus(pausDevIDList[bAnyIndex], &fOkayToStartScan, &fScanning);
		if(fScanning) 
		{ 
			pabScanStartedList[bAnyIndex] = 2;
			continue;
		}

		if(!fOkayToStartScan) 
		{ 
			pabScanStartedList[bAnyIndex] = 0;
			continue;
		}

		bScanType_Local = pabScanTypeList[bIndexStructDevList];


		if((bScanType_Local == CMND_SINGLE_CHAN_SCAN)
			|| (bScanType_Local == CMND_SINGLE_CHAN_DIGIN_SCAN))
		{
			structDevices[bIndexStructDevList]->ScanObject.SO_bScanArg = 0;
		}
		else
		{
			if((pausDevIDList[bAnyIndex] < 4990) && (pabNumChansList[bIndexStructDevList] > 4))
				pabNumChansList[bIndexStructDevList] = 4;
			else if((pausDevIDList[bAnyIndex] > 4990) && (pabNumChansList[bIndexStructDevList] > 8))
				pabNumChansList[bIndexStructDevList] = 8;
		}
		structDevices[bIndexStructDevList]->ScanObject.SO_bScanArg = pabNumChansList[bIndexStructDevList];


		if((bScanType_Local == CMND_SINGLE_CHAN_DIGIN_SCAN)
			|| (bScanType_Local == CMND_MULTI_CHAN_DIGIN_SCAN)
			|| (bScanType_Local == CMND_MULTI_CHAN_DIGIN_CAL_SCAN))
		{ structDevices[bIndexStructDevList]->fIsDiginScan = TRUE; }
		else { structDevices[bIndexStructDevList]->fIsDiginScan = FALSE; }


//	char gbuff[255];
//	sprintf(gbuff, 
//		"\nSO_bScanArg: %u\n",
//		structDevices[bIndexStructDevList]->ScanObject.SO_bScanArg);
//	MessageBox(GetForegroundWindow(), gbuff, " NOTICE -----", 0);


		if((bScanType_Local == CMND_MULTI_CHAN_SCAN)
			|| (bScanType_Local == CMND_MULTI_CHAN_CAL_SCAN)
			|| (bScanType_Local == CMND_MULTI_CHAN_DIGIN_SCAN)
			|| (bScanType_Local == CMND_MULTI_CHAN_DIGIN_CAL_SCAN))
		{ structDevices[bIndexStructDevList]->fIsMultiChanScan = TRUE; }
		else structDevices[bIndexStructDevList]->fIsMultiChanScan = FALSE;

		structDevices[bIndexStructDevList]->ScanObject.SO_bChecksum					= 0;
		structDevices[bIndexStructDevList]->ScanObject.SO_uiStatus					= 0;
		structDevices[bIndexStructDevList]->ScanObject.SO_uiTotalPointsReadByDrvr	= 0;
		structDevices[bIndexStructDevList]->ScanObject.SO_uiPointsInBuffer			= 0;
		structDevices[bIndexStructDevList]->ScanObject.SO_bScanType					= pabScanTypeList[bIndexStructDevList];
		structDevices[bIndexStructDevList]->ScanObject.SO_dblDevRate				= structDevices[bIndexStructDevList]->dblRate;

		if(!DLL_StartScan(pausDevIDList[bAnyIndex], &structDevices[bIndexStructDevList]->ScanObject, START_SCAN_RUNNING))
		{
			uiLastAnyError = ERR_FAILED_IO;
			structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_FAILED_SCAN_STARTUP;
			pabScanStartedList[bAnyIndex] = 0;
			continue;
		}

		structDevices[bIndexStructDevList]->fScanning = TRUE;
		pabScanStartedList[bAnyIndex] = 1;
		bNumDevStartedScan++;
		fAnyDevStartedScanning = TRUE;
	}

	if(!fAnyDevStartedScanning)
		return FALSE;

	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== StartScan FUNCTION =========================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::StartScan_SP()
{
	USHORT usDevID;
	if(!GetZeroIndexDev_PRIVATE(&usDevID)) return FALSE;
	if(!StartScan(usDevID)) return FALSE;
	return TRUE;
}




//****************************************************************\
//================================================================*\
//==== StartScan FUNCTION ======================================*>
//================================================================*/
/*****************************************************************/
//* start scan single device single chan only
BOOLEAN MyLL_USB::StartScan(USHORT usDevID)
{
	BYTE bIndexStructDevList;

	if(!GetDevListIndex(usDevID, &bIndexStructDevList)) { uiLastAnyError = ERR_DEV_NOT_FOUND; return FALSE; }

	if(!GetCurDevInitStatus(usDevID))
	{ 
		// NOTE: The function call will handle setting the error code
		return FALSE;
	}

	BOOLEAN fOkayToStartScan;
	BOOLEAN fScanning;
	GetCurDevScanStatus(usDevID, &fOkayToStartScan, &fScanning);
	if(fScanning) 
	{ 
		// NOTE: The function call will handle setting the error code
		return TRUE;
	}

	if(!fOkayToStartScan) 
	{ 
		// NOTE: The function call will handle setting the error code
		return FALSE;
	}

	USHORT ausDevID[32]; ausDevID[0] = usDevID;
	USHORT* pausDevID = ausDevID;

	#define ONLY_ONE_CHAN 1
	BYTE abScanType[32]; abScanType[0] = ONLY_ONE_CHAN;
	BYTE* pabScanType = abScanType;
	
	BYTE abNumChansList[32]; abNumChansList[0] = ONLY_ONE_CHAN;
	BYTE* pabNumChansList = abNumChansList; 

	BYTE bNumDevices = 1;
	BYTE abScanStarted[32]; abScanStarted[0] = FALSE;
	BYTE* pabScanStarted = abScanStarted;

	if(!StartScan_ALL_TYPES(bNumDevices, pausDevID, pabScanType, pabNumChansList, pabScanStarted))
		return FALSE;
		
	return TRUE;

}



//****************************************************************\
//================================================================*\
//==== StartScan FUNCTION =========================================*>
//================================================================*/
/*****************************************************************/
//* start scan with options (recommend calling with only  
//  one device at a time to prevent buffer overflow.
BOOLEAN MyLL_USB::StartScan(BYTE bNumDevices, USHORT* pausDevID, BYTE* pabScanType, 
							BYTE* pabNumChans,  BYTE* pabScanStarted)
{
	StartScan_ALL_TYPES(bNumDevices, pausDevID, pabScanType, pabNumChans, pabScanStarted);
	return TRUE;
}


BOOLEAN MyLL_USB::StartScan(USHORT usDevID, BYTE bScanType, BYTE bNumChans)
{
	BYTE bIndexStructDevList;

	if(!GetDevListIndex(usDevID, &bIndexStructDevList)) { uiLastAnyError = ERR_DEV_NOT_FOUND; return FALSE; }

	if(!GetCurDevInitStatus(usDevID))
	{ 
		// NOTE: The function call will handle setting the error code
		return FALSE;
	}

	BOOLEAN fOkayToStartScan;
	BOOLEAN fScanning;
	GetCurDevScanStatus(usDevID, &fOkayToStartScan, &fScanning);
	if(fScanning) 
	{ 
		// NOTE: The function call will handle setting the error code
		return TRUE;
	}

	if(!fOkayToStartScan) 
	{ 
		// NOTE: The function call will handle setting the error code
		return FALSE;
	}

	USHORT ausDevID[32]; ausDevID[0] = usDevID;
	USHORT* pausDevID = ausDevID;

	BYTE abScanType[32]; abScanType[0] = bScanType;
	BYTE* pabScanType = abScanType;
	
	BYTE abNumChansList[32]; abNumChansList[0] = bNumChans;
	BYTE* pabNumChansList = abNumChansList; 

	BYTE bNumDevices = 1;
	BYTE abScanStarted[32]; abScanStarted[0] = FALSE;
	BYTE* pabScanStarted = abScanStarted;

//	char gbuff[255];
//	sprintf(gbuff, 
//		"\npabNumChansList: %u\n",
//		pabNumChansList[0]);
//	MessageBox(GetForegroundWindow(), gbuff, " NOTICE -----", 0);


	if(!StartScan_ALL_TYPES(bNumDevices, pausDevID, pabScanType, pabNumChansList, pabScanStarted))
		pabScanStarted[0] = FALSE;
	if(pabScanStarted[0] == FALSE)
		return FALSE;
		
	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== EndScan FUNCTION ===========================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::EndScan_SP()
{
	USHORT usDevID;
	if(!GetZeroIndexDev_PRIVATE(&usDevID)) return FALSE;
	if(!EndScan(usDevID)) return FALSE;
	return TRUE;
}




//****************************************************************\
//================================================================*\
//==== EndScan FUNCTION ===========================================*>
//================================================================*/
/*****************************************************************/
//* end scan single device
BOOLEAN MyLL_USB::EndScan(USHORT usDevID)
{
	BYTE bIndexStructDevList;

	if(!GetDevListIndex(usDevID, &bIndexStructDevList)) { uiLastAnyError = ERR_DEV_NOT_FOUND; return FALSE; }

	if(!GetCurDevInitStatus(usDevID))
	{ 
		// NOTE: The function call will handle setting the error code
		return FALSE;
	}

	BOOLEAN fOkayToStartScan;
	BOOLEAN fScanning;
	GetCurDevScanStatus(usDevID, &fOkayToStartScan, &fScanning);
	if(!fScanning) 
	{ 
		// NOTE: The function call will handle setting the error code
		return TRUE;
	}

	if(!SP_EndScan) 
	{ 
		SP_EndScan = (pSP_EndScan)GetProcAddress( hDLL, /*_T*/("SP_EndScan") ); 
		if(!SP_EndScan) 
		{ 
			uiLastAnyError = ERR_DLL_FUNCTION_NOT_FOUND;
			structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DLL_FUNCTION_NOT_FOUND;
			return FALSE; 
		} 
	}


	UINT uiValTemp = structDevices[bIndexStructDevList]->ScanObject.SO_uiStatus;
	if(uiValTemp & SCAN_HALTED)
	{
		structDevices[bIndexStructDevList]->fScanning = FALSE;
		return TRUE;
	}

	if(!SP_EndScan(usDevID))
	{
		uiLastAnyError = ERR_FAILED_IO;
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_FAILED_IO;
		//if(structDevices[bIndexStructDevList]->LocalScanDat.LS_pBuff != NULL) { delete [] structDevices[bIndexStructDevList]->LocalScanDat.LS_pBuff; structDevices[bIndexStructDevList]->LocalScanDat.LS_pBuff = NULL; }
		return FALSE; 
	}

	structDevices[bIndexStructDevList]->fScanning = FALSE;
	return TRUE;
}


//****************************************************************\
//================================================================*\
//==== GetScanData FUNCTION ======================================*>
//================================================================*/
//================================================================*\
//==== GetScanData FUNCTION ======================================*>
//================================================================*/
//================================================================*\
//==== GetScanData FUNCTION ======================================*>
//================================================================*/
//================================================================*\
//==== GetScanData FUNCTION ======================================*>
//================================================================*/
// PRIVATE FUNCTION    PRIVATE FUNCTION    PRIVATE FUNCTION =======\
// PRIVATE FUNCTION    PRIVATE FUNCTION    PRIVATE FUNCTION =======/
/*****************************************************************/
BOOLEAN MyLL_USB::GetScanData(
	USHORT usDevID, USHORT usNumPntsToReadMax,  USHORT usNumPntsToReadMin, 
	USHORT* usNumPntsRead, UINT* uiDataBuff, BOOLEAN fOkayToReadLess,
	UINT* uiStatusFlags, UINT* uiPntsInBuff, BYTE* bDiginBuff, BYTE* bLastDigin)
{
	BYTE bIndexStructDevList;

	if(!GetDevListIndex(usDevID, &bIndexStructDevList)) { uiLastAnyError = ERR_DEV_NOT_FOUND; return FALSE; }

	if(!GetCurDevInitStatus(usDevID))
	{ 
		// NOTE: The function call will handle setting the error code
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DEV_NOT_INITIALIZED;
		uiLastAnyError = ERR_DEV_NOT_INITIALIZED;
		return FALSE;
	}

	BOOLEAN fOkayToStartScan, fScanning;
	GetCurDevScanStatus(usDevID, &fOkayToStartScan, &fScanning);
	if(!fScanning) 
	{ 
		// NOTE: The function call will handle setting the error code
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DEV_NOT_SCANNING;
		uiLastAnyError = ERR_DEV_NOT_SCANNING;
		return TRUE;
	}

	BYTE bScanType_Local = structDevices[bIndexStructDevList]->ScanObject.SO_bScanType;
	BOOLEAN fIsDiginScan =  structDevices[bIndexStructDevList]->fIsDiginScan;
	BOOLEAN fIsMultiChanScan =  structDevices[bIndexStructDevList]->fIsMultiChanScan;


	if(fIsDiginScan)
	{
		if(!DLL_ReadScanDataWithDigin) 
		{ 
			DLL_ReadScanDataWithDigin = (pDLL_ReadScanDataWithDigin)GetProcAddress( hDLL, /*_T*/("DLL_ReadScanDataWithDigin") ); 
			if(!DLL_ReadScanDataWithDigin) 
			{ 
				uiLastAnyError = ERR_FAILED_IO;
				structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DLL_FUNCTION_NOT_FOUND;
				*usNumPntsRead = 0;
				return FALSE; 
			} 
		}
	}
	else
	{
		if(!DLL_ReadScanData) 
		{ 
			DLL_ReadScanData = (pDLL_ReadScanData)GetProcAddress( hDLL, /*_T*/("DLL_ReadScanData_DIO") ); 
			if(!DLL_ReadScanData) 
			{ 
				uiLastAnyError = ERR_FAILED_IO;
				structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DLL_FUNCTION_NOT_FOUND;
				*usNumPntsRead = 0;
				return FALSE; 
			} 
		}
	}

	BYTE bScanChanCnt = 1;
	UINT uiFinalPntCntToRead = 0;
	UINT usNumPntsToReadMin_Local = usNumPntsToReadMin;
	UINT usNumPntsToReadMax_Local = usNumPntsToReadMax;

	if(usNumPntsToReadMax_Local < usNumPntsToReadMin_Local) usNumPntsToReadMax_Local = usNumPntsToReadMin_Local;

	// Get point cnt
	structDevices[bIndexStructDevList]->ScanObject.SO_uiPointsInBuffer = 0;


	BYTE bCurChanForDiginScan = 0;	
	if(fIsDiginScan)
		DLL_ReadScanDataWithDigin(usDevID, uiDataBuff, bDiginBuff, &bCurChanForDiginScan, 0, &structDevices[bIndexStructDevList]->ScanObject);
	else
		DLL_ReadScanData(usDevID, uiDataBuff, 0, &structDevices[bIndexStructDevList]->ScanObject);

	UINT uiPntsInBuff_TEMP;
	UINT uiStatus;

	uiPntsInBuff_TEMP = structDevices[bIndexStructDevList]->ScanObject.SO_uiPointsInBuffer;
	*uiPntsInBuff = uiPntsInBuff_TEMP;

	uiStatus = structDevices[bIndexStructDevList]->ScanObject.SO_uiStatus;
	*uiStatusFlags = uiStatus;
	if(uiStatus & SCAN_HALTED)
	{ return FALSE; }

	BYTE bLastDiginTemp = structDevices[bIndexStructDevList]->ScanObject.SO_bDigitalInput;
	bLastDiginTemp ^= 255;
	*bLastDigin = bLastDiginTemp;

	if(fIsMultiChanScan)
	{
		bScanChanCnt = structDevices[bIndexStructDevList]->ScanObject.SO_bScanArg;

		if(
				(structDevices[bIndexStructDevList]->ScanObject.SO_bScanType == CMND_MULTI_CHAN_CAL_SCAN) 
			||	(structDevices[bIndexStructDevList]->ScanObject.SO_bScanType == CMND_MULTI_CHAN_CAL_SCAN))
		{
			if(usDevID < 4990)
			{
				if(bScanChanCnt < 4) bScanChanCnt++;
			}
			else
			{
				if(bScanChanCnt < 8) bScanChanCnt++;
			}
		}
	}

	if((uiPntsInBuff_TEMP < bScanChanCnt) || (usNumPntsToReadMin < bScanChanCnt))
	{
		uiLastAnyError = ERR_NO_ERROR;
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_NO_ERROR;
		*usNumPntsRead = 0;
		return FALSE; 
	}

	if(uiPntsInBuff_TEMP < usNumPntsToReadMax_Local) 
	{
		if((fOkayToReadLess) && (uiPntsInBuff_TEMP >= usNumPntsToReadMin_Local))
		{
			uiFinalPntCntToRead = uiPntsInBuff_TEMP;
			uiPntsInBuff_TEMP = 0;
			*uiPntsInBuff = uiPntsInBuff_TEMP;
		}
		else
		{
			uiLastAnyError = ERR_NO_ERROR;
			structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_NO_ERROR;
			*usNumPntsRead = 0;
			return FALSE; 
		}
	}
	else
	{
		uiPntsInBuff_TEMP = uiPntsInBuff_TEMP - usNumPntsToReadMax_Local;
		*uiPntsInBuff = uiPntsInBuff_TEMP;
		uiFinalPntCntToRead = usNumPntsToReadMax;
	}

	// final check to make the points read a valid amount - points read will  
	//  equal valid scans of all channels per scan.
//7-17-02	uiFinalPntCntToRead = uiFinalPntCntToRead / bScanChanCnt; uiFinalPntCntToRead = uiFinalPntCntToRead * bScanChanCnt;

	if(fIsDiginScan)
	{
		if(!DLL_ReadScanDataWithDigin(usDevID, uiDataBuff, bDiginBuff, &bCurChanForDiginScan, uiFinalPntCntToRead, &structDevices[bIndexStructDevList]->ScanObject))
		{
			// CHECK STATUS HERE
			uiLastAnyError = ERR_FAILED_IO;
			structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_FAILED_IO;
			return FALSE; 
		}
	}
	else
	{
		if(!DLL_ReadScanData(usDevID, uiDataBuff, uiFinalPntCntToRead, &structDevices[bIndexStructDevList]->ScanObject))
		{
			// CHECK STATUS HERE
			uiLastAnyError = ERR_FAILED_IO;
			structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_FAILED_IO;
			return FALSE; 
		}
	}

	*usNumPntsRead = uiFinalPntCntToRead;
	return TRUE;
}



//****************************************************************\
//================================================================*\
//==== GetScanData_USE_STRUCT FUNCTION ===========================*>
//================================================================*/
//================================================================*\
//==== GetScanData_USE_STRUCT FUNCTION ===========================*>
//================================================================*/
//================================================================*\
//==== GetScanData_USE_STRUCT FUNCTION ===========================*>
//================================================================*/
//================================================================*\
//==== GetScanData_USE_STRUCT FUNCTION ===========================*>
//================================================================*/
//****************************************************************\
//================================================================*\
// PRIVATE FUNCTION    PRIVATE FUNCTION    PRIVATE FUNCTION =======\
// PRIVATE FUNCTION    PRIVATE FUNCTION    PRIVATE FUNCTION =======/
/*****************************************************************/
BOOLEAN MyLL_USB::GetScanData_USE_STRUCT(
	PSCAN_INFO_USB_PNTS_SINGLE pScanInfoPntsSingle, DOUBLE* padblVoltages)
{
	BYTE bIndexStructDevList;
	if(!GetDevListIndex(pScanInfoPntsSingle->usDevID, &bIndexStructDevList)) { uiLastAnyError = ERR_DEV_NOT_FOUND; return FALSE; }

	if(!GetCurDevInitStatus(pScanInfoPntsSingle->usDevID))
	{ 
		// NOTE: The function call will handle setting the error code
		return FALSE;
	}

	BOOLEAN fOkayToStartScan, fScanning;
	GetCurDevScanStatus(pScanInfoPntsSingle->usDevID, &fOkayToStartScan, &fScanning);
	if(!fScanning) 
	{ 
		// NOTE: The function call will handle setting the error code
		return TRUE;
	}

	USHORT usDevID = pScanInfoPntsSingle->usDevID;

	BYTE bScanChanCnt = 1;
	UINT uiNumPntsToRead_Local = pScanInfoPntsSingle->usNumPntsToRead;

	if(!DLL_ReadScanData) 
	{ 
		DLL_ReadScanData = (pDLL_ReadScanData)GetProcAddress( hDLL, /*_T*/("DLL_ReadScanData_DIO") ); 
		if(!DLL_ReadScanData) 
		{ 
			uiLastAnyError = ERR_FAILED_IO; 
			structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DLL_FUNCTION_NOT_FOUND; 
			pScanInfoPntsSingle->usNumPntsToRead = 0; return FALSE; 
		} 
	}

	structDevices[bIndexStructDevList]->ScanObject.SO_uiPointsInBuffer = 0;

	UINT TempDataBuff; UINT* puiDataBuff = &TempDataBuff;
	BYTE TempDiginBuff; BYTE* pbDiginBuff = &TempDiginBuff;

	// Get point cnt
	DLL_ReadScanData(pScanInfoPntsSingle->usDevID, puiDataBuff, 0, &structDevices[bIndexStructDevList]->ScanObject);

	//* set number of scans in buff before reading
	UINT uiPntsInBuff_TEMP = structDevices[bIndexStructDevList]->ScanObject.SO_uiPointsInBuffer;
	if(uiPntsInBuff_TEMP) pScanInfoPntsSingle->uiNumPntsInBuff = uiPntsInBuff_TEMP;
	else pScanInfoPntsSingle->uiNumPntsInBuff = 0;

	//* status
	UINT uiStatusFlags_TEMP = structDevices[bIndexStructDevList]->ScanObject.SO_uiStatus;
	pScanInfoPntsSingle->uiStatusFlags = uiStatusFlags_TEMP;
	if(uiStatusFlags_TEMP & SCAN_HALTED)
	{ return FALSE; }

	//* digin
	BYTE bLastDiginTemp = structDevices[bIndexStructDevList]->ScanObject.SO_bDigitalInput;
	bLastDiginTemp ^= 255; pScanInfoPntsSingle->bLastDigin = bLastDiginTemp;

	if(uiPntsInBuff_TEMP < uiNumPntsToRead_Local) 
	{
		uiLastAnyError = ERR_NO_ERROR;
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_NO_ERROR;
		return FALSE; 
	}

	puiDataBuff = new UINT[uiNumPntsToRead_Local];

	if(!DLL_ReadScanData(pScanInfoPntsSingle->usDevID, puiDataBuff, uiNumPntsToRead_Local, &structDevices[bIndexStructDevList]->ScanObject))
	{
		// CHECK STATUS HERE
		uiLastAnyError = ERR_FAILED_IO;
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_FAILED_IO;
		delete[]puiDataBuff; 
		return FALSE; 
	}

	pScanInfoPntsSingle->uiNumPntsInBuff = uiPntsInBuff_TEMP - uiNumPntsToRead_Local;

	DOUBLE dblVoltageTemp;
	UINT uiRawCount;
	for(UINT uiIndex = 0; uiIndex < uiNumPntsToRead_Local; uiIndex++)
	{
		uiRawCount = puiDataBuff[uiIndex];
		dblVoltageTemp = ((INT)uiRawCount - 8388608) * 0.00000059604645;
		padblVoltages[uiIndex] = dblVoltageTemp;
	}

	bLastDiginTemp = structDevices[bIndexStructDevList]->ScanObject.SO_bDigitalInput;
	bLastDiginTemp ^= 255;
	structDevices[bIndexStructDevList]->bLastDigin = bLastDiginTemp;
	pScanInfoPntsSingle->bLastDigin = bLastDiginTemp;

	delete[]puiDataBuff;
	
	return TRUE;
}



#include <stdio.h>

//****************************************************************\
//================================================================*\
// PRIVATE FUNCTION    PRIVATE FUNCTION    PRIVATE FUNCTION =======\
// PRIVATE FUNCTION    PRIVATE FUNCTION    PRIVATE FUNCTION =======/
/*****************************************************************/
BOOLEAN MyLL_USB::GetScanData_USE_STRUCT(
	PSCAN_INFO_USB pScanInfo, PSCAN_DATA_USB paScanData)
{
	BYTE bIndexStructDevList;
	if(!GetDevListIndex(pScanInfo->usDevID, &bIndexStructDevList)) { uiLastAnyError = ERR_DEV_NOT_FOUND; return FALSE; }

	if(!GetCurDevInitStatus(pScanInfo->usDevID))
	{ 
		// NOTE: The function call will handle setting the error code
		return FALSE;
	}

	BOOLEAN fOkayToStartScan, fScanning;
	GetCurDevScanStatus(pScanInfo->usDevID, &fOkayToStartScan, &fScanning);
	if(!fScanning) 
	{ 
		// NOTE: The function call will handle setting the error code
		return TRUE;
	}

	USHORT usDevID = pScanInfo->usDevID;


	BYTE bCurChanForDiginScan = 0;	
	BOOLEAN fIsMultiChanScan =  structDevices[bIndexStructDevList]->fIsMultiChanScan;

	BYTE bScanChanCnt = 1;
	if(fIsMultiChanScan) 
		bScanChanCnt = structDevices[bIndexStructDevList]->ScanObject.SO_bScanArg;

	BYTE bScanType_Local = structDevices[bIndexStructDevList]->ScanObject.SO_bScanType;
	BOOLEAN fIsDiginScan =  structDevices[bIndexStructDevList]->fIsDiginScan;

	UINT uiFinalPntCntToRead = 0, usNumPntsToReadMin_Local = pScanInfo->usNumScansMin * bScanChanCnt, usNumPntsToReadMax_Local = pScanInfo->usNumScansMax * bScanChanCnt;

	if(fIsDiginScan)
	{ if(!DLL_ReadScanDataWithDigin) { DLL_ReadScanDataWithDigin = (pDLL_ReadScanDataWithDigin)GetProcAddress( hDLL, /*_T*/("DLL_ReadScanDataWithDigin") );  if(!DLL_ReadScanDataWithDigin) { uiLastAnyError = ERR_FAILED_IO; structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DLL_FUNCTION_NOT_FOUND; pScanInfo->usNumScansRead = 0; return FALSE; } } }
	else
	{ if(!DLL_ReadScanData) { DLL_ReadScanData = (pDLL_ReadScanData)GetProcAddress( hDLL, /*_T*/("DLL_ReadScanData_DIO") ); if(!DLL_ReadScanData) { uiLastAnyError = ERR_FAILED_IO; structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DLL_FUNCTION_NOT_FOUND; pScanInfo->usNumScansRead = 0; return FALSE; } } }

	if(usNumPntsToReadMax_Local < usNumPntsToReadMin_Local) usNumPntsToReadMax_Local = usNumPntsToReadMin_Local;
	structDevices[bIndexStructDevList]->ScanObject.SO_uiPointsInBuffer = 0;

	UINT TempDataBuff = 0; UINT* puiDataBuff = &TempDataBuff;
	BYTE TempDiginBuff = 0; BYTE* pbDiginBuff = &TempDiginBuff;

	// Get point cnt
	if(fIsDiginScan) 
		DLL_ReadScanDataWithDigin(pScanInfo->usDevID, puiDataBuff, pbDiginBuff, &bCurChanForDiginScan, 0, &structDevices[bIndexStructDevList]->ScanObject);
	else 
		DLL_ReadScanData(pScanInfo->usDevID, puiDataBuff, 0, &structDevices[bIndexStructDevList]->ScanObject);



	//* set number of scans in buff before reading
	UINT uiPntsInBuff_TEMP = structDevices[bIndexStructDevList]->ScanObject.SO_uiPointsInBuffer;
	if(uiPntsInBuff_TEMP > bScanChanCnt) 
		pScanInfo->uiNumScansInBuff = uiPntsInBuff_TEMP / bScanChanCnt;
	else pScanInfo->uiNumScansInBuff = 0;

//7-12-02
/*
if(!fMsgBoxShownOnce)
{
	fMsgBoxShownOnce = TRUE;
	char gbuff[255];
	sprintf(gbuff, 
		"\nuiPntsInBuff_TEMP: %u\n"
		"\nbScanChanCnt: %d\n"
		"\nfIsMultiChanScan: %d\n"
		"\nfIsDiginScan: %d\n"
		"uiFinalPntCntToRead: %u\n", 
		uiPntsInBuff_TEMP,
		bScanChanCnt,
		fIsMultiChanScan,
		structDevices[bIndexStructDevList]->fIsDiginScan,
		uiFinalPntCntToRead);
	MessageBox(GetForegroundWindow(), gbuff, " NOTICE -----", 0);
}
*/

	//* status
	UINT uiStatusFlags_TEMP = structDevices[bIndexStructDevList]->ScanObject.SO_uiStatus;
	pScanInfo->uiStatusFlags = uiStatusFlags_TEMP;
	if(uiStatusFlags_TEMP & SCAN_HALTED)
	{ return FALSE; }

	//* digin
	BYTE bLastDiginTemp = structDevices[bIndexStructDevList]->ScanObject.SO_bDigitalInput;
	bLastDiginTemp ^= 255; pScanInfo->bLastDigin = bLastDiginTemp;

	if(uiPntsInBuff_TEMP < usNumPntsToReadMax_Local) 
	{
		if((pScanInfo->fOkayToReadLess) && (uiPntsInBuff_TEMP >= usNumPntsToReadMin_Local))
		{ uiFinalPntCntToRead = uiPntsInBuff_TEMP; }
		else
		{
			uiLastAnyError = ERR_NO_ERROR;
			structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_NO_ERROR;
			pScanInfo->usNumScansRead = 0;
			return FALSE; 
		}
	}
	else
	{ uiFinalPntCntToRead = usNumPntsToReadMax_Local; }

	// make the read an even number of channels
	uiFinalPntCntToRead = uiFinalPntCntToRead / bScanChanCnt; uiFinalPntCntToRead = uiFinalPntCntToRead * bScanChanCnt;

/*
if(!fMsgBoxShownOnce)
{
	fMsgBoxShownOnce = TRUE;
	char gbuff[255];
	sprintf(gbuff, 
		"\nuiPntsInBuff_TEMP: %u\n"
		"uiFinalPntCntToRead: %u\n", 
		uiPntsInBuff_TEMP,
		uiFinalPntCntToRead);
	MessageBox(GetForegroundWindow(), gbuff, " NOTICE -----", 0);
}
*/

	puiDataBuff = new UINT[uiFinalPntCntToRead]; pbDiginBuff = new BYTE[uiFinalPntCntToRead];

	if(fIsDiginScan)
	{
		if(!DLL_ReadScanDataWithDigin(pScanInfo->usDevID, puiDataBuff, pbDiginBuff, &bCurChanForDiginScan, uiFinalPntCntToRead, &structDevices[bIndexStructDevList]->ScanObject))
		{
			// CHECK STATUS HERE
			uiLastAnyError = ERR_FAILED_IO;
			structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_FAILED_IO;
			return FALSE; 
		}
	}
	else
	{
		if(!DLL_ReadScanData(pScanInfo->usDevID, puiDataBuff, uiFinalPntCntToRead, &structDevices[bIndexStructDevList]->ScanObject))
		{
			// CHECK STATUS HERE
			uiLastAnyError = ERR_FAILED_IO;
			structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_FAILED_IO;
			delete[]puiDataBuff; delete[]pbDiginBuff;
			return FALSE; 
		}
	}

	pScanInfo->uiNumScansInBuff = pScanInfo->uiNumScansInBuff - (uiFinalPntCntToRead / bScanChanCnt);
    USHORT usNumScansPerScan = (uiFinalPntCntToRead / bScanChanCnt);
	if(usDevID < 4990)
	{
		for (BYTE bScanIndex = 0; bScanIndex < usNumScansPerScan; bScanIndex++)
		{
			if(bScanChanCnt > 0)
			{
				paScanData[bScanIndex].bDataChan0 = puiDataBuff[(bScanIndex * bScanChanCnt)];
				if(fIsDiginScan) 
				{
					bLastDiginTemp = pbDiginBuff[(bScanIndex * bScanChanCnt)];  
					paScanData[bScanIndex].bDiginChan0 = (bLastDiginTemp ^= 255);
				} 
			}
			if(bScanChanCnt > 1)
			{
				paScanData[bScanIndex].bDataChan1 = puiDataBuff[(bScanIndex * bScanChanCnt) + 1];
				if(fIsDiginScan) 
				{ 
					bLastDiginTemp = pbDiginBuff[(bScanIndex * bScanChanCnt) + 1];  
					paScanData[bScanIndex].bDiginChan1 = (bLastDiginTemp ^= 255); 
				} 
			}
			if(bScanChanCnt > 2)
			{
				paScanData[bScanIndex].bDataChan6 = puiDataBuff[(bScanIndex * bScanChanCnt) + 2];
				if(fIsDiginScan) 
				{ 
					bLastDiginTemp = pbDiginBuff[(bScanIndex * bScanChanCnt) + 2];  
					paScanData[bScanIndex].bDiginChan6 = (bLastDiginTemp ^= 255); 
				} 
			}
			if(bScanChanCnt > 3)
			{
				paScanData[bScanIndex].bDataChan7 = puiDataBuff[(bScanIndex * bScanChanCnt) + 3];
				if(fIsDiginScan) 
				{ 
					bLastDiginTemp = pbDiginBuff[(bScanIndex * bScanChanCnt) + 3];  
					paScanData[bScanIndex].bDiginChan7 = (bLastDiginTemp ^= 255); 
				} 
			}
		}
	}
	else
	{
		for (BYTE bScanIndex = 0; bScanIndex < usNumScansPerScan; bScanIndex++)
		{
			if(bScanChanCnt > 0)
			{
				paScanData[bScanIndex].bDataChan0 = puiDataBuff[(bScanIndex * bScanChanCnt)];
				if(fIsDiginScan) 
				{
					bLastDiginTemp = pbDiginBuff[(bScanIndex * bScanChanCnt)];  
					paScanData[bScanIndex].bDiginChan0 = (bLastDiginTemp ^= 255);
				} 
			}
			if(bScanChanCnt > 1)
			{
				paScanData[bScanIndex].bDataChan1 = puiDataBuff[(bScanIndex * bScanChanCnt) + 1];
				if(fIsDiginScan) 
				{ 
					bLastDiginTemp = pbDiginBuff[(bScanIndex * bScanChanCnt) + 1];  
					paScanData[bScanIndex].bDiginChan1 = (bLastDiginTemp ^= 255); 
				} 
			}
			if(bScanChanCnt > 2)
			{
				paScanData[bScanIndex].bDataChan2 = puiDataBuff[(bScanIndex * bScanChanCnt) + 2];
				if(fIsDiginScan) 
				{ 
					bLastDiginTemp = pbDiginBuff[(bScanIndex * bScanChanCnt) + 2];  
					paScanData[bScanIndex].bDiginChan2 = (bLastDiginTemp ^= 255); 
				} 
			}
			if(bScanChanCnt > 3)
			{
				paScanData[bScanIndex].bDataChan3 = puiDataBuff[(bScanIndex * bScanChanCnt) + 3];
				if(fIsDiginScan) 
				{ 
					bLastDiginTemp = pbDiginBuff[(bScanIndex * bScanChanCnt) + 3];  
					paScanData[bScanIndex].bDiginChan3 = (bLastDiginTemp ^= 255);
				} 
			}
			if(bScanChanCnt > 4)
			{
				paScanData[bScanIndex].bDataChan4 = puiDataBuff[(bScanIndex * bScanChanCnt) + 4];
				if(fIsDiginScan) 
				{ 
					bLastDiginTemp = pbDiginBuff[(bScanIndex * bScanChanCnt) + 4];  
					paScanData[bScanIndex].bDiginChan4 = (bLastDiginTemp ^= 255);
				} 
			}
			if(bScanChanCnt > 5)
			{
				paScanData[bScanIndex].bDataChan5 = puiDataBuff[(bScanIndex * bScanChanCnt) + 5];
				if(fIsDiginScan) 
				{ 
					bLastDiginTemp = pbDiginBuff[(bScanIndex * bScanChanCnt) + 5];  
					paScanData[bScanIndex].bDiginChan5 = (bLastDiginTemp ^= 255); 
				} 
			}
			if(bScanChanCnt > 6)
			{
				paScanData[bScanIndex].bDataChan6 = puiDataBuff[(bScanIndex * bScanChanCnt) + 6];
				if(fIsDiginScan) 
				{ 
					bLastDiginTemp = pbDiginBuff[(bScanIndex * bScanChanCnt) + 6];  
					paScanData[bScanIndex].bDiginChan6 = (bLastDiginTemp ^= 255); 
				} 
			}
			if(bScanChanCnt > 7)
			{
				paScanData[bScanIndex].bDataChan7 = puiDataBuff[(bScanIndex * bScanChanCnt) + 7];
				if(fIsDiginScan) 
				{ 
					bLastDiginTemp = pbDiginBuff[(bScanIndex * bScanChanCnt) + 7];  
					paScanData[bScanIndex].bDiginChan7 = (bLastDiginTemp ^= 255); 
				} 
			}
		}
	}

	delete[]puiDataBuff;
	delete[]pbDiginBuff;
	
	pScanInfo->usNumScansRead = uiFinalPntCntToRead / bScanChanCnt;
	return TRUE;

}


//****************************************************************\
//================================================================*\
//==== GetScanVoltage_SP FUNCTION =================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetScanVoltage_SP(PSCAN_INFO_USB_PNTS_SINGLE pScanInfoPntsSingle, DOUBLE* padblVoltages)
{
	USHORT usDevID;
	if(!GetZeroIndexDev_PRIVATE(&usDevID)) return FALSE;
	pScanInfoPntsSingle->usDevID = usDevID;
	return GetScanData_USE_STRUCT(pScanInfoPntsSingle, padblVoltages);
}




//****************************************************************\
//================================================================*\
//==== GetScanVoltage FUNCTION ====================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN MyLL_USB::GetScanVoltage(PSCAN_INFO_USB_PNTS_SINGLE pScanInfoPntsSingle, DOUBLE* padblVoltages)
{
	return GetScanData_USE_STRUCT(pScanInfoPntsSingle, padblVoltages);
}






//****************************************************************\
//================================================================*\
//==== GetScanData FUNCTION =======================================*>
//================================================================*/
/*****************************************************************/
// read variable amount, multi or single chan, no digin.
//  uses unstructured type arguments.
BOOLEAN MyLL_USB::GetScanData(
	USHORT usDevID, USHORT usNumPntsToReadMax,  USHORT usNumPntsToReadMin, 
	USHORT* pusNumPntsRead, UINT* puiDataBuff, BOOLEAN fOkayToReadLess,
	UINT* puiStatusFlags, UINT* puiPntsInBuff, BYTE* pbLastDigin)
{
	BYTE bIndexStructDevList;

	if(!GetDevListIndex(usDevID, &bIndexStructDevList)) { uiLastAnyError = ERR_DEV_NOT_FOUND; return FALSE; }

	if(!GetCurDevInitStatus(usDevID))
	{ 
		// NOTE: The function call will handle setting the error code
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DEV_NOT_INITIALIZED;
		uiLastAnyError = ERR_DEV_NOT_INITIALIZED;
		return FALSE;
	}

	BOOLEAN fOkayToStartScan, fScanning;
	GetCurDevScanStatus(usDevID, &fOkayToStartScan, &fScanning);
	if(!fScanning) 
	{ 
		// NOTE: The function call will handle setting the error code
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DEV_NOT_SCANNING;
		uiLastAnyError = ERR_DEV_NOT_SCANNING;
		return TRUE;
	}

	BYTE bScanType_Local = structDevices[bIndexStructDevList]->ScanObject.SO_bScanType;
	BOOLEAN fIsDiginScan =  structDevices[bIndexStructDevList]->fIsDiginScan;
	BOOLEAN fIsMultiChanScan =  structDevices[bIndexStructDevList]->fIsMultiChanScan;

	BYTE* pbDiginBuff; BOOLEAN fRetVal;
	if(fIsDiginScan)
	{ pbDiginBuff = new BYTE[usNumPntsToReadMax]; }

	fRetVal = GetScanData(usDevID, usNumPntsToReadMax, usNumPntsToReadMin, pusNumPntsRead, puiDataBuff, fOkayToReadLess, puiStatusFlags, puiPntsInBuff, pbDiginBuff, pbLastDigin);

	if(fIsDiginScan) delete [] pbDiginBuff;

	return fRetVal;
}



//****************************************************************\
//================================================================*\
//==== GetScanData FUNCTION =======================================*>
//================================================================*/
/*****************************************************************/
// read variable amount, multi or single chan, with digin. Uses
//  unstructured type arguments.
BOOLEAN MyLL_USB::GetScanData(USHORT usDevID, USHORT usNumPntsToReadMax, 
	USHORT usNumPntsToReadMin, USHORT* pusNumPntsRead, UINT* puiDataBuff, 
	BYTE* pbDiginBuff, BOOLEAN fOkayToReadLess, UINT* puiStatusFlags, 
	UINT* puiPntsInBuff, BYTE* pbLastDigin)
{
	BYTE bIndexStructDevList;

	if(!GetDevListIndex(usDevID, &bIndexStructDevList)) { uiLastAnyError = ERR_DEV_NOT_FOUND; return FALSE; }

	if(!GetCurDevInitStatus(usDevID))
	{ 
		// NOTE: The function call will handle setting the error code
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DEV_NOT_INITIALIZED;
		uiLastAnyError = ERR_DEV_NOT_INITIALIZED;
		return FALSE;
	}

	BOOLEAN fOkayToStartScan, fScanning;
	GetCurDevScanStatus(usDevID, &fOkayToStartScan, &fScanning);
	if(!fScanning) 
	{ 
		// NOTE: The function call will handle setting the error code
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DEV_NOT_SCANNING;
		uiLastAnyError = ERR_DEV_NOT_SCANNING;
		return TRUE;
	}

	BYTE bScanType_Local = structDevices[bIndexStructDevList]->ScanObject.SO_bScanType;
	BOOLEAN fIsDiginScan =  structDevices[bIndexStructDevList]->fIsDiginScan;
	BOOLEAN fIsMultiChanScan =  structDevices[bIndexStructDevList]->fIsMultiChanScan;

	BOOLEAN fRetVal;

	fRetVal = GetScanData(
		usDevID, usNumPntsToReadMax, usNumPntsToReadMin, pusNumPntsRead, puiDataBuff, 
		fOkayToReadLess, puiStatusFlags, puiPntsInBuff, pbDiginBuff, pbLastDigin);


	return fRetVal;
}






//****************************************************************\
//================================================================*\
//==== GetScanData FUNCTION =======================================*>
//================================================================*/
/*****************************************************************/
// read variable amount, multi or single chan, without digin. Uses
//  unstructured type arguments.
BOOLEAN MyLL_USB::GetScanData(USHORT usDevID, USHORT usNumPntsToRead, USHORT* pusNumPntsRead, 
	UINT* pauiDataBuff, UINT* puiStatusFlags, UINT* puiPntsInBuff, BYTE* pbLastDigin)
{
	BYTE bIndexStructDevList;

	if(!GetDevListIndex(usDevID, &bIndexStructDevList)) { uiLastAnyError = ERR_DEV_NOT_FOUND; return FALSE; }

	if(!GetCurDevInitStatus(usDevID))
	{ 
		// NOTE: The function call will handle setting the error code
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DEV_NOT_INITIALIZED;
		uiLastAnyError = ERR_DEV_NOT_INITIALIZED;
		return FALSE;
	}

	BOOLEAN fOkayToStartScan, fScanning;
	GetCurDevScanStatus(usDevID, &fOkayToStartScan, &fScanning);
	if(!fScanning) 
	{ 
		// NOTE: The function call will handle setting the error code
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DEV_NOT_SCANNING;
		uiLastAnyError = ERR_DEV_NOT_SCANNING;
		return TRUE;
	}

	BYTE bScanType_Local = structDevices[bIndexStructDevList]->ScanObject.SO_bScanType;
	BOOLEAN fIsDiginScan =  structDevices[bIndexStructDevList]->fIsDiginScan;
	BOOLEAN fIsMultiChanScan =  structDevices[bIndexStructDevList]->fIsMultiChanScan;

	// this is an error for this call, but go ahead and protect by adding
	//  array for digital input
	BYTE DiginBuff_Fake;
	BYTE* pDiginBuff_Fake = &DiginBuff_Fake;
	if(fIsDiginScan)
	{
		pDiginBuff_Fake = new BYTE[usNumPntsToRead];
	}
	*pusNumPntsRead = 0;

	BOOLEAN fOkayToReadLess = FALSE;

	BOOLEAN fRetVal = GetScanData(
		usDevID, usNumPntsToRead, usNumPntsToRead, pusNumPntsRead, pauiDataBuff, 
		fOkayToReadLess, puiStatusFlags, puiPntsInBuff, pDiginBuff_Fake, pbLastDigin);

	if(fIsDiginScan)
	{ delete [] pDiginBuff_Fake; }

	return fRetVal;
}



//****************************************************************\
//================================================================*\
//==== GetScanData FUNCTION =======================================*>
//================================================================*/
/*****************************************************************/
//* read variable amoun, multi-chan, with/without digin, uses
//   structured data.
BOOLEAN MyLL_USB::GetScanData(PSCAN_INFO_USB pScanInfo, PSCAN_DATA_USB paScan)
{
	BYTE bIndexStructDevList;

	if(!GetDevListIndex(pScanInfo->usDevID, &bIndexStructDevList)) { uiLastAnyError = ERR_DEV_NOT_FOUND; return FALSE; }

	if(!GetCurDevInitStatus(pScanInfo->usDevID))
	{ 
		// NOTE: The function call will handle setting the error code
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DEV_NOT_INITIALIZED;
		uiLastAnyError = ERR_DEV_NOT_INITIALIZED;
		return FALSE;
	}

	BOOLEAN fOkayToStartScan, fScanning;
	GetCurDevScanStatus(pScanInfo->usDevID, &fOkayToStartScan, &fScanning);
	if(!fScanning) 
	{ 
		// NOTE: The function call will handle setting the error code
		structDevices[bIndexStructDevList]->uiLastErrorCodeThisDev = ERR_DEV_NOT_SCANNING;
		uiLastAnyError = ERR_DEV_NOT_SCANNING;
		return TRUE;
	}

	BOOLEAN fRetVal;

	fRetVal = GetScanData_USE_STRUCT(pScanInfo, paScan);

	return fRetVal;
}



BOOLEAN MyLL_USB::EndScan(BYTE bNumDevices, USHORT* pausDevList)
{
	return TRUE;
}

/*
if(!fMsgBoxShownOnce)
{
	fMsgBoxShownOnce = TRUE;
	char gbuff[255];
	sprintf(gbuff, "fIsMultiCha: %d, fIsDigin: %d, chanCnt: %d", 
			structDevices[bIndexStructDevList]->fIsMultiChanScan,
			structDevices[bIndexStructDevList]->fIsDiginScan,
			bNumChansList[bIndexStructDevList]);
	MessageBox(GetForegroundWindow(), gbuff, " NOTICE -----", 0);
}
*/
/*
if(!fMsgBoxShownOnce)
{
	fMsgBoxShownOnce = TRUE;
	char gbuff[255];
	sprintf(gbuff, 
		"\nuiNumScansInBuff: %u\n"
		"uiFinalPntCntToRead: %u\n"
		"usNumScansPerScan: %u\n", 
		pScanInfo->uiNumScansInBuff,
		uiFinalPntCntToRead,
		usNumScansPerScan);
	MessageBox(GetForegroundWindow(), gbuff, " NOTICE -----", 0);
}
*/


//MessageBox(GetForegroundWindow(), "Put anything here", " NOTICE -----", 0);
//MessageBox(GetForegroundWindow(), "Put anything here", " ERROR -----", 0);
